/* JavaScript content from payroll/js/controllers/payroll-overview-controller.js in folder common */ 
smbcController.controller('PayrollOverviewCtrl', function($rootScope, $scope, $state, $ionicScrollDelegate, commonServices, stagingService) {

    utility.AdobeAnalytics("TFMFFN01","まとめて振込完了","screen_view");
    /* <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< Common Functions Begin >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>*/

    // Return the number if error, otherwise, return -1
    function getErrNum(PAYROLL_TRANSFER_RESULT_LIST){
        var Error = new Object();
        for(var i=0; i<PAYROLL_TRANSFER_RESULT_LIST.length; i++){
            if(PAYROLL_TRANSFER_RESULT_LIST[i].hasOwnProperty('status')){
                if(PAYROLL_TRANSFER_RESULT_LIST[i].status == 2 || PAYROLL_TRANSFER_RESULT_LIST[i].status == 3){
                    Error.index = i;
                    Error.status = PAYROLL_TRANSFER_RESULT_LIST[i].status;
                    return Error;
                }
            }
        }
        return -1;
    }

    // Invoke different error template by the source data type
    function getTemplate(type, index, status){
        if(status === 1){ // 1-取引成功
            return GenerateData(type, index);
        }else{ // 2-取引失败 & 3-未取引
			$scope.templateFailShow = true;
            if(PAYROLL_TRANSFER_RESULT_LIST[index].hasOwnProperty('data')){
                $scope.account = PAYROLL_TRANSFER_RESULT_LIST[index].data;
                if(type === "out") {
                    return './payroll/templates/template-fail-out.html';
                } else if(type === "in") {
                    return './payroll/templates/template-fail-in.html';
                }else{  // for test using out tempalte
                }
            }

        }
    }

    // Get the correct data template
    function GenerateData(type, index){
//		$scope.usePointUmuShow = false;
    	$scope.usePointUmuShowArr = [false,false,false,false,false];
        if (type === "out") {
            $scope.previousKumimodoshiChargeSet = PAYROLL_MIA7486Z_LIST[index];

            var previoustypeCode = PAYROLL_TRANSFER_RESULT_LIST[index].data.ACCNT_INF_OUT.ACCNT_BL_TYPE;
            $scope.previousResult = PAYROLL_TRANSFER_RESULT_LIST[index].data;
            //$scope.previousResult.TEL_OUT = utility.addMaskForLastFourNum($scope.previousResult.TEL_OUT.replace(/\B(?=(?:\d{4})+(?!\d))/g, '-'));
            $scope.previousResult.TEL_OUT = utility.addMaskForLastFourNum($scope.previousResult.TEL_OUT);
            
            $scope.previousResult.FURI_AMNT = utility.formatCurrency($scope.previousResult.FURI_AMNT);
			$scope.previousResult.CHARGE = utility.formatCurrency($scope.previousResult.CHARGE);
			$scope.previousResult.CHARGE_YUGU = utility.formatCurrency($scope.previousResult.CHARGE_YUGU);
			$scope.previousResult.TOTAL_AMANT_SIA = utility.formatCurrency($scope.previousResult.TOTAL_AMANT_SIA);
            
            $scope.previousConfirmOutResultAccntBlType = CONSTS.DIRECT_API.ACCOUNT_MAPPING_KEYS[previoustypeCode].icon;
            if($scope.previousResult.USE_POINT_UMU == '1'){
//        		$scope.usePointUmuShow = true;
            	$scope.usePointUmuShowArr[index] = true;
        	}

            // 24365 10月対応　zhangld Start

            // 依頼日タイトル
            $scope.titleHikiDt = "依頼日(資金引落日)";
            // 振込日タイトル
            $scope.titleFuriDt = "振込日";
            // 振込日
            $scope.furiDateShowFlg = true;
            // 振込日メッセージ
            $scope.furiDateMsgShowFlg = true;
            $scope.furiDateMsg = "振込の資金は受付時に即時引き落とします。";
            $scope.furiDateMsgShowFlg1 = false;
            $scope.furiDateMsgShowFlg2 = false;
            $scope.furiDateMsgShowFlg3 = false;
            // 翌日メッセージ
            $scope.nextDayMsgShowFlg = true;
            $scope.nextDayMsg = "※振込先の口座の設定により、振込先への入金が振込指定日の翌営業日となる場合があります。";

            // 新旧切り替える用フラグ
            if (stagingService.isEnabled("zengin_extension")) {
                // 振込日メッセージ
                $scope.furiDateMsgShowFlg = false;
                // 翌日メッセージ
                $scope.nextDayMsgShowFlg = false;
                var furiDtForDisp = utility.date.createByDateAndTimeString($scope.previousResult.FURI_DT,'000000').toDateStringWithWeek([Messages.YEAR, Messages.MONTH, Messages.DAY, ' (', ')'], false);

                // RESERVE_FLG(予約フラグ) 1:即時 0:予約
                if ($scope.previousResult.RESERVE_FLG === CONSTS.RESERVE_FLG.INSTANT.toString()) {
                    // BANK_CD_IN_KBN(金融機関区分) 1:他行, 0:
                    if ($scope.previousResult.BANK_CD_IN_KBN === CONSTS.BANK_CD_IN_KBN.OUT.toString()) {
                        // DISP_KITYO_UMU(表示判定用取引事前記帳有無) 0: 締内 1: 締後
                        if ($scope.previousResult.DISP_KITYO_UMU === CONSTS.DISP_KITYO_UMU.IN.toString()) {
                            // CORE_MORE_FLG(全銀システム接続状態) 1: コア接続中 2: モア接続中 9: その他
                            if ($scope.previousResult.CORE_MORE_FLG === CONSTS.CORE_MORE_FLG.MOA.toString()) {
                                // 振込日
                                $scope.furiDateShowFlg = true;
                                // 振込日メッセージ
                                $scope.furiDateMsgShowFlg = false;
                                // 翌日メッセージ
                                $scope.nextDayMsgShowFlg = true;
                                $scope.nextDayMsg = Messages.TRANSFER_OUT_DATE_MESSAGE_NEXT_DAY_1;

                            } else if ($scope.previousResult.CORE_MORE_FLG === CONSTS.CORE_MORE_FLG.CORE.toString()) {
                                // 振込日
                                $scope.furiDateShowFlg = true;
                                // 振込日メッセージ
                                $scope.furiDateMsgShowFlg = false;

                            }
                        } else {
                            if ($scope.previousResult.CORE_MORE_FLG === CONSTS.CORE_MORE_FLG.MOA.toString()) {
                                // 締後入金可否（他行） 0: 入金可 1: 入金不可 2: 入金確約不能 9: その他
                                if ($scope.previousResult.MORE_SEND_FLG === CONSTS.MORE_SEND_FLG.YES.toString()) {
                                    // 振込日
                                    $scope.furiDateShowFlg = true;
                                    // 振込日メッセージ
                                    $scope.furiDateMsgShowFlg = false;
                                    // 翌日メッセージ
                                    $scope.nextDayMsgShowFlg = true;
                                    $scope.nextDayMsg = Messages.TRANSFER_OUT_DATE_MESSAGE_NEXT_DAY_2;

                                } else if ($scope.previousResult.MORE_SEND_FLG === CONSTS.MORE_SEND_FLG.NO.toString()) {
                                    // 振込日
                                    $scope.furiDateShowFlg = false;
                                    // 振込日メッセージ
                                    $scope.furiDateMsgShowFlg1 = true;
                                    $scope.furiDateMsg1 = utility.format(Messages.TRANSFER_OUT_DATE_MESSAGE_TODAY, [furiDtForDisp]);

                                } else if ($scope.previousResult.MORE_SEND_FLG === CONSTS.MORE_SEND_FLG.UNABLE.toString()) {
                                    // 振込日
                                    $scope.furiDateShowFlg = true;
                                    // 振込日メッセージ
                                    $scope.furiDateMsgShowFlg2 = true;

                                } else if ($scope.previousResult.MORE_SEND_FLG === CONSTS.MORE_SEND_FLG.OTHER.toString()) {
                                    // 振込日
                                    $scope.furiDateShowFlg = false;
                                    // 振込日メッセージ
                                    $scope.furiDateMsgShowFlg1 = true;
                                    $scope.furiDateMsg1 = utility.format(Messages.TRANSFER_OUT_DATE_MESSAGE_TODAY, [furiDtForDisp]);
                                }
                            }
                        }
                    } else {
                        // DISP_KITYO_UMU(表示判定用取引事前記帳有無) 0: 締内 1: 締後
                        if ($scope.previousResult.DISP_KITYO_UMU === CONSTS.DISP_KITYO_UMU.IN.toString()) {
                            // MORE_SEND_FLG(締後入金可否（他行）) 0: 入金可 1: 入金不可 2: 入金確約不能 9: その他
                            if ($scope.previousResult.MORE_SEND_FLG === CONSTS.MORE_SEND_FLG.OTHER.toString()) {
                                // 振込日
                                $scope.furiDateShowFlg = true;
                                // 振込日メッセージ
                                $scope.furiDateMsgShowFlg = false;
                            }
                        } else {
                            // MORE_SEND_FLG(締後入金可否（他行）) 0: 入金可 1: 入金不可 2: 入金確約不能 9: その他
                            if ($scope.previousResult.MORE_SEND_FLG === CONSTS.MORE_SEND_FLG.OTHER.toString()) {
                                // 振込日 = 引落日
                                if ($scope.previousResult.FURI_DT === $scope.previousResult.HIKI_DT) {
                                    // 振込日
                                    $scope.furiDateShowFlg = true;
                                    // 振込日メッセージ
                                    $scope.furiDateMsgShowFlg = false;
                                } else {
                                    // 振込日
                                    $scope.furiDateShowFlg = false;
                                    // 振込日メッセージ
                                    $scope.furiDateMsgShowFlg1 = true;
                                    $scope.furiDateMsg1 = utility.format(Messages.TRANSFER_OUT_DATE_MESSAGE_TODAY, [furiDtForDisp]);
                                }
                            }
                        }
                    }
                } else {
                    // 依頼日タイトル
                    $scope.titleHikiDt = "依頼日";
                    // 振込日タイトル
                    $scope.titleFuriDt = "振込日（資金引落日）";

                    // BANK_CD_IN_KBN(金融機関区分) 1:他行, 0:自行
                    if ($scope.previousResult.BANK_CD_IN_KBN === CONSTS.BANK_CD_IN_KBN.IN.toString()) {
                        // 振込日
                        $scope.furiDateShowFlg = true;
                        // 振込日メッセージ
                        $scope.furiDateMsgShowFlg1 = true;
                        $scope.furiDateMsg1 = Messages.TRANSFER_OUT_DATE_MESSAGE_TODAY_1;
                        $scope.furiDateMsgShowFlg3 = true;
                        // 翌日メッセージ
                        $scope.nextDayMsgShowFlg = true;
                        $scope.nextDayMsg = Messages.TRANSFER_OUT_DATE_MESSAGE_NEXT_DAY_2;
                    } else {
                        // 振込日
                        $scope.furiDateShowFlg = true;
                        // 振込日メッセージ
                        $scope.furiDateMsgShowFlg1 = true;
                        $scope.furiDateMsg1 = Messages.TRANSFER_OUT_DATE_MESSAGE_TODAY_1;
                        $scope.furiDateMsgShowFlg3 = true;
                    }
                }
            }

            // 24365 10月対応　zhangld end
            // 消費税対応
            if (!utility.isNothing(commonServices.storage().get('salestax_payroll_result_skip_flag')) &&
                !utility.isNothing(commonServices.storage().get('salestax_payroll_result_msg'))) {
                $scope.salesTaxMsg = commonServices.storage().get('salestax_payroll_result_skip_flag') == '0' ? commonServices.storage().get('salestax_payroll_result_msg') : ''
            } else {
                $scope.salesTaxMsg = '';
            }
            $scope.salesTaxShowFlag = !utility.isNothing($scope.salesTaxMsg);
            return './payroll/templates/template-confirm-out-result-content.html';
        } else if (type === "in") {
            var typeCodeIn = PAYROLL_TRANSFER_RESULT_LIST[index].data.ACCNT_INF_IN.ACCNT_BL_TYPE;
            var typeCodeOut = PAYROLL_TRANSFER_RESULT_LIST[index].data.ACCNT_INF_OUT.ACCNT_BL_TYPE;
            $scope.previousResult = PAYROLL_TRANSFER_RESULT_LIST[index].data;
            // $scope.previousResult.TEL_OUT = utility.addMaskForLastFourNum($scope.previousResult.TEL_OUT.replace(/\B(?=(?:\d{4})+(?!\d))/g, '-'));

            $scope.prev_transfer_in_inlist = PAYROLL_TRANSFER_RESULT_LIST[index].data.ACCNT_INF_IN;
            $scope.prev_transfer_in_inlist.type_icon = CONSTS.DIRECT_API.ACCOUNT_MAPPING_KEYS[typeCodeIn].icon;
            $scope.prev_transfer_out_outlist = PAYROLL_TRANSFER_RESULT_LIST[index].data.ACCNT_INF_OUT;
            $scope.prev_transfer_out_outlist.type_icon = CONSTS.DIRECT_API.ACCOUNT_MAPPING_KEYS[typeCodeOut].icon;
            return './payroll/templates/template-confirm-in-result-content.html';
        }else{
        }
    }


    /* <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< Common Functions End >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>*/

    //手续费

    var PAYROLL_MIA7486Z_LIST = utility.clone(commonServices.storage().get('PAYROLL_MIA7486Z_LIST'));

    //end 手续费


    var PAYROLL_NAVNUM = commonServices.storage().get('PAYROLL_NAVNUM'); //导航一共几步
    var PAYROLL_NAVNUMSELECTED = commonServices.storage().get('PAYROLL_NAVNUMSELECTED'); //导航现在是第几步
    var PAYROLL_TRANSFER_RESULT_LIST = commonServices.storage().get('PAYROLL_TRANSFER_RESULT_LIST'); //结果集
    // var PAYROLL_MIA7486K = commonServices.storage().get('PAYROLL_MIA7486K'); //振入数据源
    // var PAYROLL_MIA7821 = commonServices.storage().get('PAYROLL_MIA7821'); //振替数据源
    $scope.templateFailShow = false;
    if(utility.isNothing(PAYROLL_TRANSFER_RESULT_LIST)){
        return;
    }
    // get the number which 件目中断
    	var Error = getErrNum(PAYROLL_TRANSFER_RESULT_LIST);
        if(typeof(Error) === 'number'){
            var ErrNum = getErrNum(PAYROLL_TRANSFER_RESULT_LIST);
        }else if(typeof(Error) === 'object'){
            if(Error.hasOwnProperty('index')){
                var ErrNum = Error.index;
            }
            if(Error.hasOwnProperty('status')){
                $scope.ErrStatus = parseInt(Error.status);
                if($scope.ErrStatus === 2){
                    $scope.errTitle = Messages.PAYROLL_OVERVIEW_Title_Error;
                    $scope.errSubTitle = Messages.PAYROLL_OVERVIEW_SubTitle_Error;
                }else if($scope.ErrStatus === 3){
                    $scope.errTitle = Messages.PAYROLL_OVERVIEW_Title_Pause;
                }
            }
        }

        for(var i=0; i<PAYROLL_TRANSFER_RESULT_LIST.length; i++){
            PAYROLL_TRANSFER_RESULT_LIST[i].repAccountExtenedFlag = true; // default: set accordion to close
            PAYROLL_TRANSFER_RESULT_LIST[i].status = parseInt(PAYROLL_TRANSFER_RESULT_LIST[i].status ); // transfer string to int
        }

        $scope.payrollNavNumSelected = PAYROLL_NAVNUMSELECTED;
        $scope.payrollNavNum = PAYROLL_NAVNUM;
        $scope.repAccountExtenedFlag = true;
        $scope.previousResultShow = true;
     var checkError = function() {
        if(ErrNum === -1){ // no error
            ErrNum = PAYROLL_TRANSFER_RESULT_LIST.length - 1;
            $scope.hasErr = false;
            $scope.ErrNum = ErrNum + 1;
        }else{
            $scope.hasErr = true;
            // var msg = PAYROLL_TRANSFER_RESULT_LIST[ErrNum].error.errormsg;
            if(PAYROLL_TRANSFER_RESULT_LIST[ErrNum].status === 2){
                if(PAYROLL_TRANSFER_RESULT_LIST[ErrNum].hasOwnProperty('err')){
                    if(PAYROLL_TRANSFER_RESULT_LIST[ErrNum].err.hasOwnProperty('errorcode')){
                        var title = PAYROLL_TRANSFER_RESULT_LIST[ErrNum].err.errorcode;
                    }
                    if(PAYROLL_TRANSFER_RESULT_LIST[ErrNum].err.hasOwnProperty('errormessage')){
                        var msg = PAYROLL_TRANSFER_RESULT_LIST[ErrNum].err.errormessage;
                    }
                }
            }

            $scope.ErrNum = ErrNum + 1;
        }
    }
     $scope.$on('$ionicView.enter',function(e){
         if (commonServices.storage().get('POINT_ERR_FLG_SIA')) {
             var point_err_flg_sia = commonServices.storage().get('POINT_ERR_FLG_SIA');
             var isCommonPointsValid = commonServices.storage().get('isCommonPointsValid');
             //isCommonPointsValid 0:指定時間前 1:指定時間後
             //point_err_flg_sia gszz7487aレスポンス
             if (point_err_flg_sia == 1 && isCommonPointsValid == "1") {
                 commonServices.showAlert(
                       Messages.TRANSFER_OUT_POINT_ERR_FLG_SIA_1_TITLE,
                       Messages.TRANSFER_OUT_POINT_ERR_FLG_SIA_1_MESSAGE, [{
                             text: Messages.YES,
                             onTap: function(e) {
                                  commonServices.storage().set('POINT_ERR_FLG_SIA', 0);
                                  checkError();
                             }
                 }]);
             } else {
                checkError();
             }
          } else {
             checkError();
          }
     });



    $scope.item = PAYROLL_TRANSFER_RESULT_LIST;
    console.log("PAYROLL_TRANSFER_RESULT_LIST: " + PAYROLL_TRANSFER_RESULT_LIST);
    //click '+' or '-' to show or hide representative account info
    $scope.toggleAccountDetail = function(index){
        if(utility.isNothing(index)){
            $scope.repAccountExtenedFlag = !$scope.repAccountExtenedFlag;
        }else{
            $scope.item[index].repAccountExtenedFlag = !$scope.item[index].repAccountExtenedFlag;
        }
        $ionicScrollDelegate.resize();
    };
  
    //out = 振入 in = 振替
    /*
     Logic
     1. 如果参数为空,就显示最后一条记录。
     2. 如果参数不为空,就显示列表数据。
     2.1 如果数据是正确的,就显示对应的记录。
     2.2 如果取引失败, title-显示红字【 取引できませんでした。 】& 显示对应模板
     2.3 如果是未取引, title-显示未取引 & 显示对应模板

     status :
     • 1-success   (取引成功)
     • 2-fail      (取引失败)
     • 3-none      (取引中断)
     */
    $scope.viewTemplate = function (type, index, status) {
        if(utility.isNothing(type)){ //返回的是status=2的记录
           return getTemplate(PAYROLL_TRANSFER_RESULT_LIST[ErrNum].type, ErrNum, PAYROLL_TRANSFER_RESULT_LIST[ErrNum].status);

        }else{
            return getTemplate(type, index, status);
        }
    }

    $scope.showError = function(){
            commonServices.showAlert( utility.isNothing(title) ? '' : utility.format(Messages.FORMAT_ERROR_CODE, [title]),
            utility.isNothing(msg) ? '' : msg, [ {
                text : Messages.YES,
                onTap : function(e) {

                }
            }]
        );
    }
})
