/* JavaScript content from payroll/js/services/payroll-out-service.js in folder common */ 

/* JavaScript content from smcc/smcc-service.js in folder common */
/**
 * Created by alan on 7/25/16.
 */
smbcService.factory('payrollOutService',function($q,$timeout,commonServices,payrollOutDao,$rootScope,payrollTransferService){
	var selectedTab = '0';
	var MIA7480Obj;
	var sortValue = 'REGI_no_ASC';
	var tmpSearchArray = [];
	var searchFlag = true; // default hide the search section
	var _resetMIA7480Array = function(){
		tmpSearchArray = JSON.parse(JSON.stringify(MIA7480Obj))

	};
	var sortNickNameAgain = function(){
		/** This function is used to deal with nickname is null.
		 Comment:
		 1. tmpSearchArray must be sorted by nickname ASC first.
		 2. if nickname is null. add them to the end of tmpSearchArray.
		 */
		var tmpFlag = 0;
		var tmpArray = []
		for(i in tmpSearchArray){
			if(utility.isNothing(tmpSearchArray[i].nickname)){
				tmpFlag ++;
			}else{
				break;
			}
		}

		tmpSearchArray = tmpSearchArray.slice(tmpFlag).concat(tmpSearchArray.slice(0,tmpFlag));

	}
	var _sortByItem = function(sortKey){

		if(tmpSearchArray.length === 0){
			// _resetMIA7480Array();
			return;
		}

		switch (sortKey){
			case "Account_name_ASC":
				tmpSearchArray.sort(utility.firstBy("Account_name").thenBy("REGI_no"));
				break;
			case "Account_name_DESC":

				tmpSearchArray.sort(utility.firstBy("Account_name",-1).thenBy("REGI_no",-1));
				break;
			case "nickname_ASC":
				tmpSearchArray.sort(utility.firstBy("nickname").thenBy("Account_name").thenBy("REGI_no"));
				sortNickNameAgain();
				break;
			case "nickname_DESC":
				tmpSearchArray.sort(utility.firstBy("nickname",-1).thenBy("Account_name",-1).thenBy("REGI_no",-1));
				break;
			case "REGI_no_DESC":
				tmpSearchArray.sort(utility.firstBy("REGI_no",-1));
				break;
			default :
				//default by REGI_no_ASC
				tmpSearchArray.sort(utility.firstBy("REGI_no"));

		}


	};
	var _filterNickAndAccount = function(filterStr){
		if(utility.isNothing(filterStr)){
			return;
		}

		tmpSearchArray = [];
		for(i in MIA7480Obj){
			if(utility.convertHalfToFull(MIA7480Obj[i].nickname).indexOf(utility.convertHalfToFull(filterStr)) != -1 || utility.convertHalfToFull(MIA7480Obj[i].Account_name).indexOf(utility.convertHalfToFull(filterStr)) != -1 ){
				console.log("find");
				tmpSearchArray.push(MIA7480Obj[i]);
			}
		}
		console.log("");
		// return tmpSearchArray;
	};
	
	var _addZ = function(num){
		var numS = null;
		if(utility.hasValue(num)){
			numS = num.toString();
		}else{
			numS = '00';
		}
		if(numS.length < 2){
			numS = '0' + numS;
		}
		return numS;
	}

//	var _transErrData = function(res){
//		var errorCode;
//    	var errorMessage;
//        if(res.header.resultCode == CONSTS.VPASS_KEY.resultCode_9){
//    		errorMessage = Messages.VPASS_LOGIN_ERROR_8_9;
//    	}else if(res.header.resultCode == CONSTS.VPASS_KEY.resultCode_8){
//    		if(utility.isNothing(res.body.vpassError.errorDetails[0].errorMessages[0].message)){
//    			errorMessage = Messages.VPASS_LOGIN_ERROR_8_9;
//    		}else{
//    			errorMessage = res.body.vpassError.errorDetails[0].errorMessages[0].message;
//    		}
//    	}else{
//    		errorCode = res.body.validationErrors[0].errorMessages[0].key;
//    		errorMessage = res.body.validationErrors[0].errorMessages[0].message;
//    	}
//    	
//        if(errorCode == CONSTS.VPASS_KEY.login_code_005){
//        	errorMessage = Messages.VPASS_LOGIN_MSG_005;
//        }else if(errorCode == CONSTS.VPASS_KEY.login_code_051){
//        	errorMessage = Messages.VPASS_LOGIN_MSG_051;
//        }
//        return {errorCode:errorCode,errorMessage:errorMessage};
//	};
	
	var _fixAccountIndex = function(accountIndex, branchName, accountTypeCode, accountNumber, accounts) {
		if (utility.isNothing(accountIndex)) {
			return accountIndex; // 元々値なし（空文字列を含む）の場合は更新不要
		}
		if (!branchName || !accountTypeCode || !accountNumber) {
			console.error("matching parameter missing: accountIndex="+accountIndex+",branchName="+branchName+",accountTypeCode="+accountTypeCode+",accountNumber="+accountNumber);
			return accountIndex; // 突合条件不足（これらに値0や値falseは含まれないので!xxxで十分）
		}
		if (!accounts) {
			console.error("accounts from MIA7880 not available");
			return accountIndex; // リスト取得前 or 画面が終了してから呼び出されている
		}
		for (var i in accounts) {
			var account = accounts[i];
			if (account.branchName == branchName && account.accountTypeCode == accountTypeCode && account.accountNumber == accountNumber) {
				return accountIndex != account.originalAccountIndex ? account.originalAccountIndex : accountIndex;
			}
		}
		return accountIndex; // 対応する口座が見つからない
	};
	var _prepareAccountIndexFixer = function(scope, mia7880accounts, fnWithIndexFixer) {
		if (!scope || scope.$id === $rootScope.$id) throw "$scope must be specified";
		var accounts = mia7880accounts;
		scope.$on('$ionicView.leave', function (e) {
			accounts = null; // 消し忘れがないよう、画面を出たらリストを破棄する
		});
		if (!accounts) {
			cashless.getSharedData('transferInFrom7880', function(result) {
				accounts = JSON.parse(result.transferInFrom7880.ACCNT_BL_INF);
				fnWithIndexFixer && fnWithIndexFixer(indexFixer);
			});
		}
		var indexFixer = function(accountIndex, branchName, accountTypeCode, accountNumber) {
			return _fixAccountIndex(accountIndex, branchName, accountTypeCode, accountNumber, accounts);
		};
		return indexFixer;
	};

	return {
		queryAllGroups : function(fixAccountIndex){
			fixAccountIndex = fixAccountIndex || function(index) { return index; }; // fallback to identity
			var deferred = $q.defer();
			payrollOutDao.queryAllGroups().then(
				function(result){
					var useritems = [];
					if(utility.hasValue(result)){
						for(var i = 0; i < result.rows.length; i++){
							var item = new Object();
							item.id = result.rows.item(i).primaryKey;
							item.name = result.rows.item(i).group_name;
							item.rowid = _addZ(result.rows.item(i).back1);
							var row = result.rows.item(i);
							item.pay_account_index = row.pay_account_index;
							item.pay_account_index1 = fixAccountIndex(row.pay_account_index1, row.pay_branch_name, row.pay_account_type_code, row.pay_account_no);
							useritems.push(item);
						}
					}
					
	    			deferred.resolve({code:'0',data:useritems});
	    		},
	    		function(error){
	    			deferred.reject({code:'1',data:useritems});
	    		}
			);
			return deferred.promise;
        },
        queryGroupsById : function(groupId, fixAccountIndex){
			fixAccountIndex = fixAccountIndex || function(index) { return index; }; // fallback to identity
			var deferred = $q.defer();
			payrollOutDao.queryGroupsById(groupId).then(
				function(result){
					
					var transferoutlists = [];
					var transferinlists = [];
					var groupInfo = {};
					for (var i = 0; i < result.rows.length; i++) {
						var row = result.rows.item(i);
						var obj = new Object();
						if (i == 0) {
							groupInfo = new Object();
							groupInfo.groupId = row.group_id;
							groupInfo.groupName = row.group_name;

							groupInfo.pay_account_index = fixAccountIndex(row.pay_account_index, row.pay_branch_name, row.pay_account_type_code, row.pay_account_no);
							groupInfo.pay_account_index1 = fixAccountIndex(row.pay_account_index1, row.pay_branch_name, row.pay_account_type_code, row.pay_account_no);
							groupInfo.Branch = row.pay_branch_name;
							groupInfo.AccountName = row.pay_account_type;
							groupInfo.pay_account_type_code = row.pay_account_type_code;
							groupInfo.AccountNum = row.pay_account_no;
						}
						if (row.type_flg === '1') {
							obj.id = row.detail_id;
							obj.idx = row.idx;
							obj.price = parseFloat(row.value);
							obj.name = row.nickName;
							obj.bank = row.bank_name;
							obj.branch = row.branch_name;
							obj.type = row.account_type;
							obj.number = row.account_no;
							obj.logintype = "登録番号";
							obj.loginnum = row.record_no;
							obj.account_index = row.account_index;
							obj.bank_code = row.bank_code;
							obj.branch_code = row.branch_code;
							obj.account_type_code = row.account_type_code;
							obj.account_name = row.account_name;
//							if(utility.isNothing(obj.name)){
//								obj.nameDisplay = false;
//							}else{
//								obj.nameDisplay = true;
//							}
							transferoutlists.push(obj);
						} else {
							obj.id = row.detail_id;
							obj.idx = row.idx;
							obj.price = parseFloat(row.value);
							obj.name = '振替先 00' + obj.idx;
							obj.branchname = row.branch_name;
							obj.type = row.account_type;
							obj.number = row.account_no;
							obj.account_index = fixAccountIndex(row.account_index, row.branch_name, row.account_type_code, row.account_no);
							obj.account_index1 = fixAccountIndex(row.account_index1, row.branch_name, row.account_type_code, row.account_no);
							obj.account_type_code = row.account_type_code;
							transferinlists.push(obj);
						}
					}
					
					payrollTransferService.merageNickNameList(transferoutlists).then(
						function(resMer) {
							if(utility.isNothing(transferoutlists) || transferoutlists.length === 0){
								commonServices.storage().set('PAYROLL_TRANSFEROUTLISTS', []);
							}else{
								commonServices.storage().set('PAYROLL_TRANSFEROUTLISTS', transferoutlists);
							}

							if(utility.isNothing(transferinlists) || transferinlists.length === 0){
								commonServices.storage().set('PAYROLL_TRANSFERINLISTS', []);
							}else{
								commonServices.storage().set('PAYROLL_TRANSFERINLISTS', transferinlists);
							}
							if(utility.hasValue(groupInfo)){
								commonServices.storage().set('PAYROLL_GROUPINFO', groupInfo);
							}else{
								commonServices.storage().set('PAYROLL_GROUPINFO', {});
							}
							
			    			deferred.resolve(result);
						},
						function(error){
							deferred.reject(error);
						}
					);
	    		},
	    		function(error){
	    			deferred.reject(error);
	    		}
			);
			return deferred.promise;
        },
        // nativeから引き継いだMIA7880口座一覧情報を元に、DBに保存されたオリジナル口座INDEXを補正するfunctionを生成する。
        // 取得したfunctionは画面内のみ有効であり、加工せずに queryAllGroups(), queryGroupsById() に渡す必要がある。
		// パラメータ mia7880accounts を省略する場合は取得処理が非同期になるため、使用直前ではなく事前に（例えばcontrollerの初期化関数で）呼び出す必要がある。
		// 口座一覧情報取得後の処理を保証したい場合は、withIndexFixer() の使用も検討すること。
        // @param scope 呼出元画面の$scopeオブジェクト（$rootScopeは使用不可）
        // @param mia7880accounts MIA7880応答のACCNT_BL_INF部分を読み込んだ配列(optional)。省略時は新たにshared dataから取得する
        getAccountIndexFixer: function(scope, mia7880accounts) {
			return _prepareAccountIndexFixer(scope, mia7880accounts, null);
		},
		// getAccountIndexFixer() と同様のfunction（以下indexFixerと呼称）を生成する。
		// また、口座情報の取得が完了した際に、indexFixerを引数としてfnWithIndexFixerを呼び出す。
		// 他の箇所でも使用したい場合の便宜のため、戻り値としてもindexFixerを返すが、
		// こちらを使う場合は非同期で初期化中の可能性があることに留意すること。
		withAccountIndexFixer: function(scope, fnWithIndexFixer) {
			return _prepareAccountIndexFixer(scope, null, fnWithIndexFixer);
		},
        createOrUpdateGroup : function(transferoutlists,transferinlists,groupInfo) {
        	var deferred = $q.defer();
        	payrollOutDao.createOrUpdateGroup(transferoutlists,transferinlists,groupInfo).then(
				function(result){
	    			deferred.resolve(result);
	    		},
	    		function(error){
	    			deferred.reject(error);
	    		}
			);
			return deferred.promise;
		},
		checkGroupName: function(groupName,groupId) {
        	var deferred = $q.defer();
        	payrollOutDao.checkGroupName(groupName,groupId).then(
				function(result){
	    			deferred.resolve(result);
	    		},
	    		function(error){
	    			deferred.reject(error);
	    		}
			);
			return deferred.promise;
		},
		deleteGroupById: function(groupId) {
        	var deferred = $q.defer();
        	payrollOutDao.deleteGroupById(groupId).then(
				function(result){
	    			deferred.resolve(result);
	    		},
	    		function(error){
	    			deferred.reject(error);
	    		}
			);
			return deferred.promise;
		},
		setSelectedTab: function(tab){
			selectedTab = tab;
		},
		getSelectedTab: function(){
			return selectedTab;
		},
		deleteGroupItemFromMem: function(item,flg){
			var haveDel = false;
			var key = 'PAYROLL_TRANSFEROUTLISTS';
			if(flg === '2'){
				key = 'PAYROLL_TRANSFERINLISTS';
			}
			var transferlists = commonServices.storage().get(key);
			var len = transferlists.length;
			for(var i = 0; i < len; i++){
				if(item.idx == transferlists[i].idx && item.number == transferlists[i].number){
					transferlists.splice(i,1);
					if(i != len - 1){
						haveDel = true;
					}
					len = len - 1;
				}
				if(haveDel){
					transferlists[i].idx = transferlists[i].idx - 1;
					
					if(flg === '2'){
						transferlists[i].name = '振替先 00' + transferlists[i].idx;
					}
				}
			}
			return transferlists;
		},

		// Search function begin
		setSortValue: function(val){
			sortValue = val;
		},
		getSortValue: function(){
			return sortValue;
		},
		getSortMIA7480Array : function(){
			return tmpSearchArray;
		},
		resetMIA7480Array : function(){
			_resetMIA7480Array();
		},
		setMIA7480 : function(obj){
			var tmpArr = [];
			if(obj.constructor === Object ){
				for(i in obj){
					tmpArr.push(obj[i]);
				}
				MIA7480Obj = tmpArr;
			}else{
				MIA7480Obj = obj;
			}
		},
		getMIA7480 : function(){
			return MIA7480Obj;
		},
		
		filterNickAndAccount : function(filterStr){

			_filterNickAndAccount(filterStr);

		},

		sortByItem : function(sortKey){
			_sortByItem(sortKey);
		},

		//当server端的口座和作成的group里的振入口座不一致时，显示message
		showTransferOutError : function(transferoutresponsedata,transferoutlists){
			var isDel=false;
			$rootScope.showerrorflag =false;
			var transferoutresponse_data_length;
			if(transferoutresponsedata == null){
				transferoutresponse_data_length = 0;
			}else{
				transferoutresponse_data_length = commonServices.storage().get('transferOutFrom7480').data.REGI_ACCNT_CNT_SIA;
			}
				
			for(var i in transferoutlists){
				var number = transferoutlists[i].number;
				var bank_code =transferoutlists[i].bank_code;
				var bank =transferoutlists[i].bank;
				var branch_code =transferoutlists[i].branch_code;
				var branch =transferoutlists[i].branch;
				var type =transferoutlists[i].type;
				var account_name =transferoutlists[i].account_name;
				if(transferoutresponse_data_length > 0){
					for(var j in transferoutresponsedata){
						var Account_no =transferoutresponsedata[j].Account_no;
						var Bank_code =transferoutresponsedata[j].Bank_code;
						var Bank_name =transferoutresponsedata[j].Bank_name;
						var Branch_code =transferoutresponsedata[j].Branch_code;
						var Branch_name =transferoutresponsedata[j].Branch_name;
						var Account_type =transferoutresponsedata[j].Account_type;
						var Account_name =transferoutresponsedata[j].Account_name;
						if(number == Account_no && bank_code == Bank_code && bank == Bank_name && branch_code== Branch_code && branch == Branch_name
								&&type == Account_type && account_name == Account_name){
							transferoutlists[i].showerrorflag = false;
							transferoutlists[i].loginnum = transferoutresponsedata[j].REGI_no;
//							transferoutlists[i].checked = true;
							break;
						}else{
							transferoutlists[i].showerrorflag = true;
//							transferoutlists[i].checked = false; 
						}
					}
				}else{
					transferoutlists[i].showerrorflag = true;
//					transferoutlists[i].checked = false; 
				}

			}
			//遍历list里的flag标记，寻找是否有不一致的口座
			for(var i = 0; i < transferoutlists.length; i++){
				if(transferoutlists[i].showerrorflag == true){
					isDel=true;
					break;
				}else{
					isDel=false;
				}
			}
			return isDel;
		},
		//当server端的口座和作成的group里的振替口座不一致时，显示message
		showTransferInError : function(lists,transferinlists){
			var isDel=false;
			$rootScope.showerrorflag =false;
			var listlength=commonServices.storage().get('transferInFrom7880').data.ACCNT_BL_NUMBER;
			for(var i in transferinlists){
				var number = transferinlists[i].number;
				var account_type_code = transferinlists[i].account_type_code;
				var branchname = transferinlists[i].branchname;
				var type = transferinlists[i].type;
				if(listlength > 0){
					for(var j in lists){
						var AccountNum =lists[j].AccountNum;
						var ACCNT_BL_TYPE =lists[j].ACCNT_BL_TYPE;
						var Branch =lists[j].Branch;
						var AccountName =lists[j].AccountName;
						if(number == AccountNum && account_type_code == ACCNT_BL_TYPE && branchname == Branch && type == AccountName){
							transferinlists[i].showerrorflag = false;
							transferinlists[i].checked = true; 
							break;
						}else{
							transferinlists[i].showerrorflag = true;
							transferinlists[i].checked = false; 
						}
					}
				}else{
					transferinlists[i].showerrorflag = true;
				}
			}
			//遍历list里的flag标记，寻找是否有不一致的口座
			for(var i = 0; i < transferinlists.length; i++){
				if(transferinlists[i].showerrorflag == true){
					isDel=true;
					break;
				}else{
					isDel=false;
				}
			}
			return isDel;
		},
		showTransferOutAllError : function(transferoutresponsedata,transferoutlists){
			var isDel=false;
			$rootScope.showerrorflag =false;
			//if(utility.isNothing(transferoutlists) || transferoutlists.length <= 0){
			//	return false;
			//}
			var transferoutresponse_data_length=0;
			if(utility.hasValue(commonServices.storage().get('transferOutFrom7480')) && 
					utility.hasValue(commonServices.storage().get('transferOutFrom7480').data)){
				transferoutresponse_data_length=commonServices.storage().get('transferOutFrom7480').data.REGI_ACCNT_CNT_SIA;
			}
			for(var i in transferoutlists){
				var number = transferoutlists[i].number;
				var bank_code =transferoutlists[i].bank_code;
				var bank =transferoutlists[i].bank;
				var branch_code =transferoutlists[i].branch_code;
				var branch =transferoutlists[i].branch;
				var type =transferoutlists[i].type;
				var account_name =transferoutlists[i].account_name;
				if(transferoutresponse_data_length > 0){
					for(var j in transferoutresponsedata){
						var Account_no =transferoutresponsedata[j].Account_no;
						var Bank_code =transferoutresponsedata[j].Bank_code;
						var Bank_name =transferoutresponsedata[j].Bank_name;
						var Branch_code =transferoutresponsedata[j].Branch_code;
						var Branch_name =transferoutresponsedata[j].Branch_name;
						var Account_type =transferoutresponsedata[j].Account_type;
						var Account_name =transferoutresponsedata[j].Account_name;
						if(number == Account_no && bank_code == Bank_code && bank == Bank_name && branch_code== Branch_code && branch == Branch_name
								&&type == Account_type && account_name == Account_name){
							transferoutlists[i].showerrorflag = false; 
							transferoutlists[i].checked = true; 
							break;
						}else{
							transferoutlists[i].showerrorflag = true;
							transferoutlists[i].checked = false; 
						}
					}
				}else{
					transferoutlists[i].showerrorflag = true;
				}

			}
			//遍历list里的flag标记，只要有一条正常（showerrorflag=false）就不显示popup
			var isDel = true;
			for(var i = 0; i < transferoutlists.length; i++){			
				if(transferoutlists[i].showerrorflag == false){
					isDel = false;
					return isDel;
				}
			}
			return isDel;
		},
		showTransferInAllError : function(lists,transferinlists){
			var isDel=false;
			$rootScope.showerrorflag =false;
			if(utility.isNothing(transferinlists) || transferinlists.length <= 0){
				return false;
			}
			var listlength=0;
			if(utility.hasValue(commonServices.storage().get('transferInFrom7880')) && 
					utility.hasValue(commonServices.storage().get('transferInFrom7880').data)){
				listlength=commonServices.storage().get('transferInFrom7880').data.ACCNT_BL_NUMBER;
			}
			for(var i in transferinlists){
				var number = transferinlists[i].number;
				var account_type_code = transferinlists[i].account_type_code;
				var branchname = transferinlists[i].branchname;
				var type = transferinlists[i].type;
				if(listlength > 0){
					for(var j in lists){
						var AccountNum =lists[j].AccountNum;
						var ACCNT_BL_TYPE =lists[j].ACCNT_BL_TYPE;
						var Branch =lists[j].Branch;
						var AccountName =lists[j].AccountName;
						if(number == AccountNum && branchname == Branch && type == AccountName){
							transferinlists[i].showerrorflag = false; 
							transferinlists[i].checked = true;
							break;
						}else{
							transferinlists[i].showerrorflag = true;
							transferinlists[i].checked = false;
						}
					}
				}else{
					transferinlists[i].showerrorflag = true;
				}
			}
			//遍历list里的flag标记，只要有一条正常（showerrorflag=false）就不显示popup
			var isDel = true;
			for(var i = 0; i < transferinlists.length; i++){
				if(transferinlists[i].showerrorflag  == false){
					isDel = false;
					return isDel;
				}
			}
			return isDel;
		},
		// compare 振込+振替 with 出金
		checkPayment : function(remit, transfer, payment, balanceShow){
			var remitMoney = 0;
			var transferMoney = 0;
			var flag = false;
			if(utility.isNothing(remit) || remit.length == 0 || !balanceShow){
				return flag;
			}
			
			// 振込
			for(var r in remit){
				if(remit[r].hasOwnProperty('price') && remit[r].checked){
					remitMoney += parseFloat(remit[r].price);
				}
			}
			//振替
			for(var t in transfer){
				if(transfer[t].hasOwnProperty('price') && transfer[t].checked){
					transferMoney += parseFloat(transfer[t].price);
				}
			}

			payment = parseFloat(payment);
			// 口座里面的残高，要多于汇款金额合计
			if(remitMoney + transferMoney > payment){
				flag = true;
			}
			return flag;
		},
		//setSearchFlag
		setSearchFlag : function(value){
			searchFlag = value;
		},
		getSearchFlag : function(){
			return searchFlag;
		}
    }
})
