/* JavaScript content from payroll/js/services/payroll-transfer-service.js in folder common */ 
/**
 * Created by alan on 12/20/16.
 */
smbcService.factory('payrollTransferService',function($q,$state,$timeout,commonServices,transferOutService,$rootScope,userService,transferOutRequestService){
	var _searchAccount = function(idx,accList,len){
		var item = new Object();
		if(len > 0){
			for(var accObj in accList){
				if(accList[accObj].Detail_index_ori === idx){
					item.Detail_index_ori = accList[accObj].Detail_index_ori;
					item.Branch = accList[accObj].Branch;
					item.AccountName = accList[accObj].AccountName;
					item.ACCNT_BL_TYPE = accList[accObj].ACCNT_BL_TYPE;
					item.AccountNum = accList[accObj].AccountNum;
					break;
				}
			}
			
		}
		return item;
	};
	var _merageNickName = function(BANK_NM_IN,BRANCH_NM_IN,ACCNT_TYPE_NM_IN,ACCNT_NO_IN,RECEIVER_NM_KN){
		var deferred = $q.defer();
		var payeeList = [];
		var payeeObj = {};
		payeeObj.Bank_name = BANK_NM_IN;
		payeeObj.Branch_name = BRANCH_NM_IN;
		payeeObj.Account_type = ACCNT_TYPE_NM_IN;
		payeeObj.Account_no = ACCNT_NO_IN;
		payeeObj.Account_name = RECEIVER_NM_KN;
		payeeList.push(payeeObj);
		userService.mergePayeeList(payeeList).then(function(reqMer){
			console.log('merageNickName success');
			var payeeData = {
					BANK_NM_IN: BANK_NM_IN,
					BRANCH_NM_IN: BRANCH_NM_IN,
					ACCNT_TYPE_NM_IN: ACCNT_TYPE_NM_IN,
					ACCNT_NO_IN: ACCNT_NO_IN,
					RECEIVER_NM_KN: RECEIVER_NM_KN,
					nickname: payeeList[0].nickname,
					avatar: payeeList[0].avatar
			};
			deferred.resolve(payeeData);
		}, function(error){
			console.log('merageNickName error' + error);
			deferred.reject(error);
		});
		return deferred.promise;
	}
	var _transferInterrupt = function(payrollNavNum,payrollNavNumSelected){
		
		var payrollSelectedList=commonServices.storage().get('PAYROLL_SELECTEDLIST');	
		for(var i = payrollNavNumSelected-1 ; i < payrollNavNum; i++){
			var item =new Object();
			item.status=3;
			item.type=payrollSelectedList[i].transferType;
			item.data=payrollSelectedList[i];
			var PAYROLL_TRANSFER_RESULT_LIST = commonServices.storage().get('PAYROLL_TRANSFER_RESULT_LIST');
			if(utility.isNothing(PAYROLL_TRANSFER_RESULT_LIST)){
				PAYROLL_TRANSFER_RESULT_LIST = [];
				commonServices.storage().set('PAYROLL_TRANSFER_RESULT_LIST',PAYROLL_TRANSFER_RESULT_LIST);
			}
		commonServices.storage().get('PAYROLL_TRANSFER_RESULT_LIST').push(item);
		}
	}
	var _transferInterruptTest=function(payrollNavNum,payrollNavNumSelected,errCode,errMessage){
		var payrollSelectedList=commonServices.storage().get('PAYROLL_SELECTEDLIST');
		for(var i = payrollNavNumSelected-1 ; i < payrollNavNum; i++){
			var item =new Object();
			item.err=new Object();

		if(utility.isNothing(errCode)){
			errCode="";
		}if(utility.isNothing(errMessage)){
			errMessage=Messages.PAYROLL_OVERVIEW_SubTitle_Error;
		}
		if(i+1>payrollNavNumSelected){
			item.status=3;
		}else{
			item.status=2;
		}
		item.err.errorcode=errCode;
		item.err.errormessage=errMessage;
		item.type=payrollSelectedList[i].transferType;
		item.data=payrollSelectedList[i];
		var PAYROLL_TRANSFER_RESULT_LIST = commonServices.storage().get('PAYROLL_TRANSFER_RESULT_LIST');
		if(utility.isNothing(PAYROLL_TRANSFER_RESULT_LIST)){
		PAYROLL_TRANSFER_RESULT_LIST = [];
		commonServices.storage().set('PAYROLL_TRANSFER_RESULT_LIST',PAYROLL_TRANSFER_RESULT_LIST);
		}
		commonServices.storage().get('PAYROLL_TRANSFER_RESULT_LIST').push(item);
		}
		}
	var _reqTransferOutEditData = function(data,scope){
		var deferred = $q.defer();
		
		var params = {
			TrxID : 'MIA7486',
			'imgZandakaSap.y' : '1',
			ACCNT_IDX : transferOutService.converNullToBlank(data.ACCNT_IDX),
			CLIENT_NM : commonServices.encodeUnicodeString(transferOutService.converNullToBlank(data.CLIENT_NM)),
			TEL_OUT : transferOutService.converNullToBlank(data.TEL_OUT),
			PAY : 0,
			TESURYO_KOMI : '0',
			SELECT_USE_POINT : '0',
			CHG_YUGU_RATE : '',
			CHARGE_YUGU_IN : '0',
			RECEIVER_NM_KN : commonServices.encodeUnicodeString(transferOutService.converNullToBlank(data.RECEIVER_NM_KN)),
			FURIKOMI_SHITEI_IDX : '0',
			BANCS_DISP_MSG_FLG : '0'
		};
		onCodeError = function(code, message, scope){
			commonServices.showAlert(utility.format(Messages.FORMAT_ERROR_CODE, [code]),
//				utility.replaceHref(message),
				message,
				[{
					text : Messages.YES,
					onTap : function(evt) {
						if(code == "00179-E"/*W6002*/){
							//goto the finish page
                    		var payrollNavNum = commonServices.storage().get('PAYROLL_NAVNUM');
                    		var payrollNavNumSelected = commonServices.storage().get('PAYROLL_NAVNUMSELECTED');
                    		_transferInterruptTest(payrollNavNum, payrollNavNumSelected, code, message);
							if ($rootScope.currentTab == "tab.setting") {
                            	$state.go('tab.setting-page-payroll-overview');
                        	} else {
                            	$state.go('tab.page-payroll-overview');
                        	}
						}
					}
				}]
			);
		};
		
		commonServices.sendRequest({
			url: 'transferreceiverdetail',
			data: params,
			config: {
				'FURIKOMI_SHITEI_INF_SIA': CONSTS.DIRECT_API.ACCOUNT_DETAILS.FURIKOMI_SHITEI_INF_SIA
			},
			onCodeError: onCodeError,
			scope: scope				
		}).then(function(res7486Z){
			utility.showBusy();
			console.log('service MIA7486_EDIT imgZandakaSap.y call sucess');
			//做成select框日期处的新格式
			var data = setTransferDate(res7486Z.data);
			commonServices.storage().set('PAYROLL_MIA7486Z_EDIT', data);
			deferred.resolve({code:'0',data:{message:'MIA7486Z_EDIT imgZandakaSap.y sucess'}});
		}, function(error){
			console.log('service MIA7486_EDIT imgZandakaSap.y call error');
			commonServices.storage().set('PAYROLL_MIA7486Z_EDIT',null);
			deferred.reject({code:'1',data:{message:error}});
		});
		
		return deferred.promise;
	};
	var _reqTransferInEditData = function(scope){
		var deferred = $q.defer();
		
		var params = {
			TrxID : 'MIA7820',
			'imgFurikaeSap.y' : '1'
		};
		onCodeError = function(code, message, scope){
            commonServices.showAlert(utility.format(Messages.FORMAT_ERROR_CODE, [code]),
                utility.replaceHref(message),
                [{
                    text : Messages.YES,
                    onTap : function(evt) {
                        if(code == "00839-E"/*W6262*/){
                        	var payrollNavNum = commonServices.storage().get('PAYROLL_NAVNUM');
                    		var payrollNavNumSelected = commonServices.storage().get('PAYROLL_NAVNUMSELECTED');
                    		_transferInterruptTest(payrollNavNum, payrollNavNumSelected, code, message);
							if ($rootScope.currentTab == "tab.setting") {
                            	$state.go('tab.setting-page-payroll-overview');
                        	} else {
                            	$state.go('tab.page-payroll-overview');
                        	}
                        }
                    }
                }]
            );
        }
		commonServices.sendRequest({
			data: params,
            url: 'accounttransfer',
            config: {
                'ACCNT_INF_SIA': {
                    0 : 'Detail_index_ori',
                    1 : 'Branch',
                    2 : 'AccountName',
                    3 : 'ACCNT_BL_TYPE',
                    4 : 'AccountNum'
                },
                scope: scope
            },
            onCodeError: onCodeError
		}).then(function(res7820F){
			utility.showBusy();
			console.log('service MIA7820_EDIT imgFurikaeSap.y call sucess');
			commonServices.storage().set('PAYROLL_MIA7820F_EDIT', res7820F.data);
			deferred.resolve({code:'0',data:{message:'MIA7820_EDIT imgFurikaeSap.y sucess'}});
		}, function(error){
			console.log('service MIA7820_EDIT imgFurikaeSap.y call error');
			commonServices.storage().set('PAYROLL_MIA7820F_EDIT',null);
			deferred.reject({code:'1',data:{message:error}});
		});
	
		return deferred.promise;
	};
	var _reqTransferInData7821 = function(item,scope){
		var deferred = $q.defer();
		
		// 1.MIA7821
		var option ={
			ACCNT_IDX:item.ACCNT_IDX,
			ACCNT_IDX_FURIKAE:item.ACCNT_IDX_FURIKAE,
			PAY:item.PAY.toString().replace(/\b(0+)/gi,""),
		};
		option['imgFukaNextSap.y'] = '1';
		option.TrxID='MIA7821';

		onCodeError = function(code, message, scope){          	
    		commonServices.showAlert(utility.format(Messages.FORMAT_ERROR_CODE, [code]),
                message,
                [{
                    text : Messages.YES,
                    onTap : function(evt) {
                    	if(code == "00013-E"/*W6134*/ || code == "00011-E"/*W6348*/ ||
                			code == "00189-E"/*A6066*/
        				){
                    		utility.showBusy();
                    		_reqTransferInEditData(scope).then(
                				function(result) {     
                					commonServices.storage().set('PAYROLL_JUMP_ERROR', true);
                					console.log('success');
                					utility.hideBusy();
                					if ($rootScope.currentTab == "tab.setting") {
   										$state.go('tab.setting-page-confirm-edit-amount');
  									}else{
  										$state.go('tab.page-confirm-edit-amount');
  									}
                				},
                				function(error) {
                					utility.hideBusy();
                					console.log('error');
                				}
                			);                       		
                    	}else if(code == "09000-E"/*W6002*/ || code == "09000-E"/*W6132*/ ||
                    			code == "00751-E"/*W6133*/ || code == "00185-E"/*A6122*/ ||
                    			code == "02842-E"/*A6122*/ || code == "02818-E"/*A6122*/ || code == "02049-E"/*A6122*/ ||
                    			code == "00166-E"/*A6131*/ || code == "01657-E"/*A6257*/)
                    	{
                    		var payrollNavNum = commonServices.storage().get('PAYROLL_NAVNUM');
                    		var payrollNavNumSelected = commonServices.storage().get('PAYROLL_NAVNUMSELECTED');
                    		_transferInterruptTest(payrollNavNum, payrollNavNumSelected, code, message);
							if ($rootScope.currentTab == "tab.setting") {
                            	$state.go('tab.setting-page-payroll-overview');
                        	} else {
                            	$state.go('tab.page-payroll-overview');
                        	}
                    	}
                    }
                }]
    		);            	                   
        }
		
		commonServices.sendRequest({
			url: 'accounttransferone',
			data:option,
			config: {
				'ACCNT_INF_SIA': {
					0 : 'Detail_index_ori',
					1 : 'Branch',
					2 : 'AccountName',
					3 : 'ACCNT_BL_TYPE',
					4 : 'AccountNum'
				}
			},
			onServerError: function(status, message) {
         	   console.log("onServerError");
            },
            //error handle
            onCodeError: onCodeError,
			scope: scope
		}).then(function(response){
			console.log('service MIA7821 call success');
			var PAYROLL_MIA7821 = utility.clone(response.data);
			PAYROLL_MIA7821.ACCNT_INF_OUT = _searchAccount(response.data.ACCNT_IDX,response.data.ACCNT_INF_SIA,response.data.ACCNT_CNT_SIA);
			PAYROLL_MIA7821.ACCNT_INF_IN = _searchAccount(response.data.ACCNT_IDX_FURIKAE,response.data.ACCNT_INF_SIA,response.data.ACCNT_CNT_SIA);
			
			commonServices.storage().set('PAYROLL_MIA7821',PAYROLL_MIA7821);
			deferred.resolve({code:'0',data:{message:'MIA7821 sucess'}});
		}, function(error){
			console.log('service MIA7821 call error');
			commonServices.storage().set('PAYROLL_MIA7821',null);
			deferred.reject({code:'1',data:{message:error}});
		});
			
		return deferred.promise;
	};
	var _reqTransferInData = function(item,scope){
		var deferred = $q.defer();
		
		var params = {};
		var onCodeError = null;
		var url = null;
		var config = {};
		
		params = {
			TrxID : 'MIA7820',
			'imgFurikaeSap.y' :'1'
		};
		url = 'accounttransfer';
		config = {
			'ACCNT_INF_SIA': {
				0 : 'Detail_index_ori',
				1 : 'Branch',
				2 : 'AccountName',
				3 : 'ACCNT_BL_TYPE',
				4 : 'AccountNum'
			}
		};
		onCodeError=function(code, message, scope){
			commonServices.showAlert(utility.format(Messages.FORMAT_ERROR_CODE, [code]),
				utility.replaceHref(message),
				[{
					text : Messages.YES,
					onTap : function(evt) {
						//$state.go('tab.top');
					}
				}]
			);
		};
		
		commonServices.sendRequest({
			data: params,
			url: url,
			config: config,
			onCodeError:onCodeError
		}).then(
			function(res7820){
				utility.showBusy();
				console.log('The IF 7820 call success.');
				commonServices.storage().set('PAYROLL_MIA7820_IN',res7820.data);
				
				//Defect 2118
				var servicesFirstAccountList = utility.clone(commonServices.storage().get('PAYROLL_MIA7820_IN').ACCNT_INF_SIA);
				var newFirstAccountInObj;
				var newFirstAccountOutObj;
				for(var i in servicesFirstAccountList){
					if((servicesFirstAccountList[i].Branch === item.branchname) && (servicesFirstAccountList[i].AccountName === item.type) && 
							(servicesFirstAccountList[i].ACCNT_BL_TYPE === item.account_type_code) && (servicesFirstAccountList[i].AccountNum === item.number)){
						newFirstAccountInObj = utility.clone(servicesFirstAccountList[i]);
					}
					if((servicesFirstAccountList[i].Branch === item.Branch) && (servicesFirstAccountList[i].AccountName === item.AccountName) && 
							(servicesFirstAccountList[i].ACCNT_BL_TYPE === item.pay_account_type_code) && (servicesFirstAccountList[i].AccountNum === item.AccountNum)){
						newFirstAccountOutObj = utility.clone(servicesFirstAccountList[i]);
					}
				}
				
				// 1.MIA7821
				var option ={
					ACCNT_IDX:newFirstAccountOutObj.Detail_index_ori,
					ACCNT_IDX_FURIKAE:newFirstAccountInObj.Detail_index_ori,
					PAY:item.value.toString().replace(/\b(0+)/gi,""),
				};
				option['imgFukaNextSap.y'] = '1';
				option.TrxID='MIA7821';

				onCodeError = function(code, message, scope){       	
		    		commonServices.showAlert(utility.format(Messages.FORMAT_ERROR_CODE, [code]),
		                message,
		                [{
		                    text : Messages.YES,
		                    onTap : function(evt) {
		                    	if(code == "00013-E"/*W6134*/ || code == "00011-E"/*W6348*/ ||
		                			code == "00189-E"/*A6066*/
		        				){
		                    		utility.showBusy();
		                    		_reqTransferInEditData(scope).then(
		                				function(result) {     
		                					commonServices.storage().set('PAYROLL_JUMP_ERROR', true);
		                					console.log('success');
		                					utility.hideBusy();
		                					commonServices.storage().set('PAYROLL_IN_EDIT_DATA',null);
				                			if ($rootScope.currentTab == "tab.setting") {
		   										$state.go('tab.setting-page-confirm-edit-amount');
		  									}else{
		  										$state.go('tab.page-confirm-edit-amount');
		  									}
		                				},
		                				function(error) {
		                					utility.hideBusy();
		                					console.log('error');
		                				}
		                			);                       		
		                    	}else if(code == "09000-E"/*W6002*/ || code == "09000-E"/*W6132*/ ||
		                    			code == "00751-E"/*W6133*/ || code == "00185-E"/*A6122*/ ||
		                    			code == "02842-E"/*A6122*/ || code == "02818-E"/*A6122*/ || code == "02049-E"/*A6122*/ ||
		                    			code == "00166-E"/*A6131*/ || code == "01657-E"/*A6257*/)
		                    	{
		                    		var payrollNavNum = commonServices.storage().get('PAYROLL_NAVNUM');
		                    		var payrollNavNumSelected = commonServices.storage().get('PAYROLL_NAVNUMSELECTED');
		                    		_transferInterruptTest(payrollNavNum, payrollNavNumSelected, code, message);
									if ($rootScope.currentTab == "tab.setting") {
                                    	$state.go('tab.setting-page-payroll-overview');
                                	} else {
                                    	$state.go('tab.page-payroll-overview');
                                	}
		                    	}
		                    }
		                }]
		    		);            	                   
		        }
				
				commonServices.sendRequest({
					url: 'accounttransferone',
					data:option,
					config: {
						'ACCNT_INF_SIA': {
							0 : 'Detail_index_ori',
							1 : 'Branch',
							2 : 'AccountName',
							3 : 'ACCNT_BL_TYPE',
							4 : 'AccountNum'
						}
					},
					onServerError: function(status, message) {
		         	   console.log("onServerError");
		            },
		            //error handle
		            onCodeError: onCodeError,
					scope: scope
				}).then(function(response){
					utility.showBusy();
					console.log('service MIA7821 call success');
					var PAYROLL_MIA7821 = utility.clone(response.data);
					PAYROLL_MIA7821.ACCNT_INF_OUT = _searchAccount(response.data.ACCNT_IDX,response.data.ACCNT_INF_SIA,response.data.ACCNT_CNT_SIA);
					PAYROLL_MIA7821.ACCNT_INF_IN = _searchAccount(response.data.ACCNT_IDX_FURIKAE,response.data.ACCNT_INF_SIA,response.data.ACCNT_CNT_SIA);
					
					commonServices.storage().set('PAYROLL_MIA7821',PAYROLL_MIA7821);
					deferred.resolve({code:'0',data:{message:'MIA7821 sucess'}});
				}, function(error){
					console.log('service MIA7821 call error');
					commonServices.storage().set('PAYROLL_MIA7821',null);
					deferred.reject({code:'1',data:{message:error}});
				});
//				deferred.resolve({code:'0',data:{message:'success'}});
			},
			function(error){
				console.log('The IF 7820 call error' + error);
				commonServices.storage().set('PAYROLL_MIA7820_IN',null);
				deferred.reject({code:'1',data:{message:'faile'}});
			}
		);
		
		return deferred.promise;
	}
	var setTransferDate = function(data){
		// convert the transfer date to add the index.
	    //defect 5171
		var transferPreDateArr = data.FURIKOMI_SHITEI_INF_SIA;
		var transferDateIndex = data.FURIKOMI_SHITEI_IDX;
		data.transferDateArr = convertTranferDate(data.FURIKOMI_SHITEI_INF_SIA);
		if(utility.hasValue(data.transferDateArr) && data.transferDateArr.length > 0 && utility.isNothing(data.transferDateIndex)){
			if(transferPreDateArr.length === 0){
				data.transferDateIndex = data.transferDateArr[0].transferDateIndex
			}else{
				if(transferPreDateArr[0].transDateNoFormat === data.transferDateArr[0].transDateNoFormat){
					data.transferDateIndex = data.transferDateArr[transferDateIndex].transferDateIndex;
				}else{
					if(transferDateIndex === '0'){
						data.transferDateIndex = data.transferDateArr[transferDateIndex].transferDateIndex;
					}else{
						data.transferDateIndex = data.transferDateArr[Number(transferDateIndex) - 1].transferDateIndex;
					}
					
				}
			}			
		}
		return data;
	};
	// convert the transfer date to add the index.
	var convertTranferDate = function(transferDateObj){
		var transferDateArr =[];
		if(typeof(transferDateObj) == 'object'){
			var item = {};
			for(var key in transferDateObj){
				item = transferDateObj[key];
				item.transferDateIndex = key;
				item.transDateNoFormat = item.Tran_date;
				item.Tran_date = utility.date.createByDateAndTimeString(item.Tran_date,'000000').toDateString('{0}年{1}月{2}日');
				transferDateArr.push(item);
			}
		}
//		transferOutService.setTransferDateArr(transferDateArr);
		return transferDateArr;
	};
	var _showTransferOutAllError = function(transferoutresponsedata,transferoutlists){
		var isDel=false;
		$rootScope.showerrorflag =false;
		//if(utility.isNothing(transferoutlists) || transferoutlists.length <= 0){
		//	return false;
		//}
		var transferoutresponse_data_length=0;
		if(utility.hasValue(commonServices.storage().get('transferOutFrom7480')) && 
				utility.hasValue(commonServices.storage().get('transferOutFrom7480').data)){
			transferoutresponse_data_length=commonServices.storage().get('transferOutFrom7480').data.REGI_ACCNT_CNT_SIA;
		}
		for(var i in transferoutlists){
			var number = transferoutlists[i].number;
			var bank_code =transferoutlists[i].bank_code;
			var bank =transferoutlists[i].bank;
			var branch_code =transferoutlists[i].branch_code;
			var branch =transferoutlists[i].branch;
			var type =transferoutlists[i].type;
			var account_name =transferoutlists[i].account_name;
			if(transferoutresponse_data_length > 0){
				for(var j in transferoutresponsedata){
					var Account_no =transferoutresponsedata[j].Account_no;
					var Bank_code =transferoutresponsedata[j].Bank_code;
					var Bank_name =transferoutresponsedata[j].Bank_name;
					var Branch_code =transferoutresponsedata[j].Branch_code;
					var Branch_name =transferoutresponsedata[j].Branch_name;
					var Account_type =transferoutresponsedata[j].Account_type;
					var Account_name =transferoutresponsedata[j].Account_name;
					if(number == Account_no && bank_code == Bank_code && bank == Bank_name && branch_code== Branch_code && branch == Branch_name
							&&type == Account_type && account_name == Account_name){
						transferoutlists[i].showerrorflag = false; 
						transferoutlists[i].checked = true; 
						break;
					}else{
						transferoutlists[i].showerrorflag = true;
						transferoutlists[i].checked = false; 
					}
				}
			}else{
				transferoutlists[i].showerrorflag = true;
			}

		}
		//遍历list里的flag标记，只要有一条正常（showerrorflag=false）就不显示popup
		var isDel = true;
		for(var i = 0; i < transferoutlists.length; i++){			
			if(transferoutlists[i].showerrorflag == false){
				isDel = false;
				return isDel;
			}
		}
		return isDel;
	}
//	var _loopCheckFor7482 = function(data7480,idx,siaLength,isNeed7480,scope,item) {
//		var deferred = $q.defer();
//
//		var onCodeError7486 = function(code, message, scope) {
//			commonServices.showAlert(utility.format(
//					Messages.FORMAT_ERROR_CODE, [ code ]),
//					message, [ {
//						text : Messages.YES
//					} ]);
//		};
//		 
//		var onCodeError = function(code, message, scope) {
//			if(code != '00182-E'/*A6421*/){
//				commonServices.showAlert(utility.format(
//						Messages.FORMAT_ERROR_CODE, [ code ]),
//						message, [ {
//							text : Messages.YES
//						} ]);
//			}else{
//				if(idx < siaLength){
//					_loopCheckFor7482(data7480,idx + 1,siaLength,isNeed7480,scope,item).then(
//						function(result) {
//							console.log('Loop for 7482 success!');
//							deferred.resolve({code:'0',data:{message:'success'}});
//						},
//						function(error){
//							console.log('Loop for 7482 error' + error);
//							deferred.reject({code:'1',data:{message:'faile'}});
//						}
//					);
//				}else{
//					if(isNeed7480 == 2){
//						// give user transfer in page.
//						deferred.resolve({code:'0',data:{message:'success'}});
//					}else{
//						commonServices.showAlert(utility.format(Messages.FORMAT_ERROR_CODE, [code]),
//				                message, [{
//				                    text: Messages.YES
//				                }]
//						);
//					}
//				}
//			}
//			
//		};
//
//		var REGIST_NO = data7480.REGI_ACCNT_INF_SIA[idx].REGI_no;
//		if(utility.isNothing(REGIST_NO)){
//			REGIST_NO = '001';
//		}
//		
//		var params = {
//				TrxID : 'MIA7482',
//				TORIHIKI_KBN : '1',
//				REGIST_NO : REGIST_NO,
//				rdoNyukin : '0',
//				FURIKOMI_KUBUN : '01',
//				'imgFurikomiSelectSap.y' : '1'
//		};
//		commonServices.sendRequest({
//			data: params,
//			url: 'transferaccountlistbybank',
//			config: {
//				'ACCNT_INF_SIA': CONSTS.DIRECT_API.ACCOUNT_DETAILS.ACCNT_INF_SIA
//			},
//			onCodeError: onCodeError,
//			scope: scope
//		}).then(
//			function(res7482){
//				utility.showBusy();
//				console.log('service MIA7482 imgFurikomiSelectSap.y call sucess');
//				commonServices.storage().set('PAYROLL_MIA7482', res7482.data);
//				
//				// 2.MIA7486 imgZandakaSap.y
//				var params = {
//					TrxID : 'MIA7486',
//					'imgZandakaSap.y' : '1',
//					ACCNT_IDX : transferOutService.converNullToBlank(item.pay_account_index1),
//					CLIENT_NM : commonServices.encodeUnicodeString(transferOutService.converNullToBlank(res7482.data.MEMBER_KANA_NAME)),
//					TEL_OUT : transferOutService.converNullToBlank(res7482.data.MEMBER_TEL_NO),
//					PAY : 0,
//					TESURYO_KOMI : '0',
//					SELECT_USE_POINT : '0',
//					CHG_YUGU_RATE : '',
//					CHARGE_YUGU_IN : '0',
//					RECEIVER_NM_KN : commonServices.encodeUnicodeString(transferOutService.converNullToBlank(res7482.data.RECEIVER_NM_KN)),
//					FURIKOMI_SHITEI_IDX : '0',
//					BANCS_DISP_MSG_FLG : '0'
//				};
//				commonServices.sendRequest({
//					url: 'transferreceiverdetail',
//					data: params,
//					config: {
//						'FURIKOMI_SHITEI_INF_SIA': CONSTS.DIRECT_API.ACCOUNT_DETAILS.FURIKOMI_SHITEI_INF_SIA
//					},
//					onCodeError: onCodeError7486,
//					scope: scope
//				}).then(function(res7486Z){
//					utility.showBusy();
//					console.log('service MIA7486 imgZandakaSap.y call sucess');
//					commonServices.storage().set('PAYROLL_MIA7486Z', res7486Z.data);
//					
//					deferred.resolve({code:'0',data:{message:'success'}});
//				},function(error){
//					console.log('service MIA7486 imgZandakaSap.y call error');
//					commonServices.storage().set('PAYROLL_MIA7486Z', null);
//					deferred.reject({code:'1',data:{message:'faile'}});
//				})
//			},function(error){
//				console.log('service MIA7482 imgFurikomiSelectSap.y call error');
//				commonServices.storage().set('PAYROLL_MIA7482', null);
//				if(error.code != '00182-E'/*A6421*/ || (error.code === '00182-E'/*A6421*/ && idx >= siaLength)){
//					deferred.reject({code:'1',data:{message:'faile'}});
//				}
//			}
//		);
//		
//		return deferred.promise;
//	};
	var _loopCheckFor7482 = function(data7480,idx,siaLength,isNeed7480,scope,item,PAYROLL_TRANSFEROUTLISTS_NOCHANGE) {
		var deferred = $q.defer();

		var onCodeError7486 = function(code, message, scope) {
			commonServices.showAlert(utility.format(
					Messages.FORMAT_ERROR_CODE, [ code ]),
					message, [ {
						text : Messages.YES
					} ]);
		};
		 
		var onCodeError = function(code, message, scope) {
			if(code != '00182-E'/*A6421*/){
				commonServices.showAlert(utility.format(
						Messages.FORMAT_ERROR_CODE, [ code ]),
						message, [ {
							text : Messages.YES
						} ]);
			}else{
				if(idx + 1 < siaLength){
					_loopCheckFor7482(data7480,idx + 1,siaLength,isNeed7480,scope,item,PAYROLL_TRANSFEROUTLISTS_NOCHANGE).then(
						function(result) {
							console.log('Loop for 7482 success!');
							deferred.resolve({code:'0',data:{message:'success'}});
						},
						function(error){
							console.log('Loop for 7482 error' + error);
							deferred.reject({code:'1',data:{message:'faile'}});
						}
					);
				}else{
					if(isNeed7480 == 2){
						// give user transfer in page.
						deferred.resolve({code:'0',data:{message:'success'}});
					}else{
						commonServices.showAlert(utility.format(Messages.FORMAT_ERROR_CODE, [code]),
				                message, [{
				                    text: Messages.YES
				                }]
						);
					}
				}
			}
		};

		var REGIST_NO = PAYROLL_TRANSFEROUTLISTS_NOCHANGE[idx].loginnum;
		if(utility.isNothing(REGIST_NO)){
			REGIST_NO = '001';
		}
		
		var params = {
				TrxID : 'MIA7482',
				TORIHIKI_KBN : '1',
				REGIST_NO : REGIST_NO,
				rdoNyukin : '0',
				FURIKOMI_KUBUN : '01',
				'imgFurikomiSelectSap.y' : '1'
		};
		commonServices.sendRequest({
			data: params,
			url: 'transferaccountlistbybank',
			config: {
				'ACCNT_INF_SIA': CONSTS.DIRECT_API.ACCOUNT_DETAILS.ACCNT_INF_SIA
			},
			onCodeError: onCodeError,
			scope: scope
		}).then(
			function(res7482){
				utility.showBusy();
				console.log('service MIA7482 imgFurikomiSelectSap.y call sucess');
				commonServices.storage().set('PAYROLL_MIA7482', res7482.data);
				
				// 2.MIA7486 imgZandakaSap.y
				var params = {
					TrxID : 'MIA7486',
					'imgZandakaSap.y' : '1',
					ACCNT_IDX : transferOutService.converNullToBlank(item.pay_account_index1),
					CLIENT_NM : commonServices.encodeUnicodeString(transferOutService.converNullToBlank(res7482.data.MEMBER_KANA_NAME)),
					TEL_OUT : transferOutService.converNullToBlank(res7482.data.MEMBER_TEL_NO),
					PAY : 0,
					TESURYO_KOMI : '0',
					SELECT_USE_POINT : '0',
					CHG_YUGU_RATE : '',
					CHARGE_YUGU_IN : '0',
					RECEIVER_NM_KN : commonServices.encodeUnicodeString(transferOutService.converNullToBlank(res7482.data.RECEIVER_NM_KN)),
					FURIKOMI_SHITEI_IDX : '0',
					BANCS_DISP_MSG_FLG : '0'
				};
				commonServices.sendRequest({
					url: 'transferreceiverdetail',
					data: params,
					config: {
						'FURIKOMI_SHITEI_INF_SIA': CONSTS.DIRECT_API.ACCOUNT_DETAILS.FURIKOMI_SHITEI_INF_SIA
					},
					onCodeError: onCodeError7486,
					scope: scope
				}).then(function(res7486Z){
					utility.showBusy();
					console.log('service MIA7486 imgZandakaSap.y call sucess');
					commonServices.storage().set('PAYROLL_MIA7486Z', res7486Z.data);
					
					deferred.resolve({code:'0',data:{message:'success'}});
				},function(error){
					console.log('service MIA7486 imgZandakaSap.y call error');
					commonServices.storage().set('PAYROLL_MIA7486Z', null);
					deferred.reject({code:'1',data:{message:'faile'}});
				})
			},function(error){
				console.log('service MIA7482 imgFurikomiSelectSap.y call error');
				commonServices.storage().set('PAYROLL_MIA7482', null);
				if(error.code != '00182-E'/*A6421*/ || (error.code === '00182-E'/*A6421*/ && idx + 1 >= siaLength)){
					deferred.reject({code:'1',data:{message:'faile'}});
				}
			}
		);
		
		return deferred.promise;
	};
	return {
		reqTransferOutData : function(item,scope){
			var deferred = $q.defer();
			
			// 1.MIA7482 imgFurikomiSelectSap.y
			// 2.MIA7486 imgZandakaSap.y
			// 3.MIA7486 imgKakuninSap.y
			
			// 『選択』押下時　＝＞ 「振込先」を選択時
			// 1.MIA7482 imgFurikomiSelectSap.y
			var params = {
				TrxID : 'MIA7482',
				TORIHIKI_KBN : '1',
				REGIST_NO : transferOutService.converNullToBlank(item.REGI_no),
				rdoNyukin : '0',
				FURIKOMI_KUBUN : '01',
				'imgFurikomiSelectSap.y' : '1'
			};
			onCodeError = function(code, message, scope){          	
        		commonServices.showAlert(utility.format(Messages.FORMAT_ERROR_CODE, [code]),
//                    utility.replaceHref(message),
        			  message,
                    [{
                        text : Messages.YES,
                        onTap : function(evt) {
                        	if(code == "00177-E"/*A6121*/ || code == "00860-E"/*W6720*/ ||
                    			code == "00853-E"/*W6124*/ || code == "00185-E"/*A6122*/ || code == "02049-E"/*A6122*/ ||
                    			code === "02844-E"/*A6122*/ || code === "02832-E"/*A6122*/ || code === "02833-E"/*A6122*/ || code === "02834-E"/*A6122*/ ||
                    			code === "02835-E"/*A6122*/ || code === "02836-E"/*A6122*/ || code === "02837-E"/*A6122*/ ||
                        		code == "00182-E"/*A6421*/ || code == "02018-E"/*A6425*/ ||
                        		code == "02019-E"/*A6426*/ || code == "00863-E"/*W1528*/ ||
                        		code == "00864-E"/*W1529*/
                        	){
	                        	var payrollNavNum = commonServices.storage().get('PAYROLL_NAVNUM');
	                    		var payrollNavNumSelected = commonServices.storage().get('PAYROLL_NAVNUMSELECTED');
	                    		_transferInterruptTest(payrollNavNum, payrollNavNumSelected, code, message);
								if ($rootScope.currentTab == "tab.setting") {
                                	$state.go('tab.setting-page-payroll-overview');
                            	} else {
                                	$state.go('tab.page-payroll-overview');
                            	}
                        	}
                        }
                    }]
        		);            	                   
            }
			commonServices.sendRequest({
				data: params,
				url: 'transferaccountlistbybank',
				config: {
					'ACCNT_INF_SIA': CONSTS.DIRECT_API.ACCOUNT_DETAILS.ACCNT_INF_SIA
				},
				onCodeError: onCodeError,
				scope: scope
			}).then(function(res7482){
				utility.showBusy();
				console.log('service MIA7482 imgFurikomiSelectSap.y call sucess');
				commonServices.storage().set('PAYROLL_MIA7482', res7482.data);
				
				// 『残高照会』押下時 => 「口座」選択時
				// 2.MIA7486 imgZandakaSap.y
				var params = {
					TrxID : 'MIA7486',
					'imgZandakaSap.y' : '1',
					ACCNT_IDX : transferOutService.converNullToBlank(item.accntIdx),
					CLIENT_NM : commonServices.encodeUnicodeString(transferOutService.converNullToBlank(res7482.data.MEMBER_KANA_NAME)),
					TEL_OUT : transferOutService.converNullToBlank(res7482.data.MEMBER_TEL_NO),
					PAY : item.value,
					TESURYO_KOMI : '0',
					SELECT_USE_POINT : '0',
					CHG_YUGU_RATE : '',
					CHARGE_YUGU_IN : '0',
					RECEIVER_NM_KN : commonServices.encodeUnicodeString(transferOutService.converNullToBlank(res7482.data.RECEIVER_NM_KN)),
					FURIKOMI_SHITEI_IDX : '0',
					BANCS_DISP_MSG_FLG : '0'
				};
				onCodeError = function(code, message, scope){          	
	        		commonServices.showAlert(utility.format(Messages.FORMAT_ERROR_CODE, [code]),
//	                    utility.replaceHref(message),
	        			message,
	                    [{
	                        text : Messages.YES,
	                        onTap : function(evt) {
	                        	if(code == "00179-E"/*W6002*/){
	                        		var payrollNavNum = commonServices.storage().get('PAYROLL_NAVNUM');
		                    		var payrollNavNumSelected = commonServices.storage().get('PAYROLL_NAVNUMSELECTED');
		                    		_transferInterruptTest(payrollNavNum, payrollNavNumSelected, code, message);
									if ($rootScope.currentTab == "tab.setting") {
                                    	$state.go('tab.setting-page-payroll-overview');
                                	} else {
                                    	$state.go('tab.page-payroll-overview');
                                	}
	                        	}		                        	
	                        }
	                    }]
	        		);            	                   
	            }
				commonServices.sendRequest({
					url: 'transferreceiverdetail',
					data: params,
					config: {
						'FURIKOMI_SHITEI_INF_SIA': CONSTS.DIRECT_API.ACCOUNT_DETAILS.FURIKOMI_SHITEI_INF_SIA
					},
					onCodeError: onCodeError,
					scope: scope
					// ,onCodeError: cusCodeError
				}).then(function(res7486Z){
					utility.showBusy();
					console.log('service MIA7486 imgZandakaSap.y call sucess');
					commonServices.storage().set('PAYROLL_MIA7486Z', res7486Z.data);
					
					// 確認画面へ
					// 3.MIA7486 imgKakuninSap.y
					var params = {
						TrxID : 'MIA7486',
						'imgKakuninSap.y' : '1',
						ACCNT_IDX : res7486Z.data.ACCNT_IDX,
						CLIENT_NM : commonServices.encodeUnicodeString(transferOutService.converNullToBlank(res7486Z.data.CLIENT_NM)),
						TEL_OUT : transferOutService.converNullToBlank(res7486Z.data.TEL_OUT),
						PAY : res7486Z.data.PAY,
						TESURYO_KOMI : '0',
						SELECT_USE_POINT : '0',
						CHG_YUGU_RATE : '',
						CHARGE_YUGU_IN : '0',
						RECEIVER_NM_KN : commonServices.encodeUnicodeString(transferOutService.converNullToBlank(res7486Z.data.RECEIVER_NM_KN)),// 'ｱｲｳｴｵｶｷｸｹ',
						FURIKOMI_SHITEI_IDX : '0',
						BANCS_DISP_MSG_FLG : '0'
					};
					
					onCodeError = function(code, message, scope){	                	
                		commonServices.showAlert(utility.format(Messages.FORMAT_ERROR_CODE, [code]),
//                            utility.replaceHref(message),
                			  message,
                            [{
                                text : Messages.YES,
                                onTap : function(evt) {
                                	if(code == "00000-E"/*W6137*/ || code == "00002-E"/*W6341*/ || code == "00007-E"/*W6341*/ ||
                            			code == "00000-E"/*W6148*/ || code == "00868-E"/*W6140*/ ||
                            			code == "00054-E"/*W6139*/ || code == "00000-E"/*W6141*/ || code == "00018-E"/*W6141*/ || code == "00013-E"/*W6141*/ ||
        	                			code == "00011-E"/*W6345*/ || code == "00866-E"/*W6138*/ ||
        	                			code == "00869-E"/*W1570*/ ||
        	                			(code == "00201-E"/*W6135*/ && utility.hasValue(commonServices.storage().get('PAYROLL_NAVNUMSELECTED')) && commonServices.storage().get('PAYROLL_NAVNUMSELECTED') >1) ||
                                        (code === "00202-E"/*W1718*/ && utility.hasValue(commonServices.storage().get('PAYROLL_NAVNUMSELECTED')) && commonServices.storage().get('PAYROLL_NAVNUMSELECTED') >1) ||
        	                			code == "00870-E"/*W1571*/ || code == "00871-E"/*W5008*/ ||
        	                			code == "00190-E"/*A5009*/ || code == "00191-E"/*A5010*/ ||
        	                			code == "00187-E"/*A6337*/ || code == "00203-E"/*A6337*/ || code == "00186-E"/*A6678*/ ||
        	                			code == "00189-E"/*A6339*/ || code == "00198-E"/*A6340*/ ||
        	                			code == "02086-I"/*W1694*/)
            	                	{	                                		
                                		//when request 7846 Kakunin error, request 7846 Zandaka again to jump to the edit page
                                		var data = utility.clone(commonServices.storage().get('PAYROLL_MIA7482')); 
                                		var group = utility.clone(commonServices.storage().get('PAYROLL_GROUPINFO'));
                                		
                                		data.ACCNT_IDX =  group.pay_account_index1;
                                		data.CLIENT_NM = data.MEMBER_KANA_NAME;
                                		data.TEL_OUT = data.MEMBER_TEL_NO;
                                		data.RECEIVER_NM_KN = data.RECEIVER_NM_KN;
                                	    
                                		utility.showBusy();
                                		_reqTransferOutEditData(data, scope).then(
                            				function(result) {                           					
                            					console.log('success');
                            					//is the previous page "group-confirm" or "confirm-edit"
                                        		commonServices.storage().set('PAYROLL_JUMP_ERROR', true);
                                        		utility.hideBusy();
					                			if ($rootScope.currentTab == "tab.setting") {
			   										$state.go('tab.setting-page-confirm-edit');
			  									}else{
			  										$state.go('tab.page-confirm-edit');
			  									}
                            				},
                            				function(error) {
                            					utility.hideBusy();
                            					console.log('error');
                            				}
                            			);
            	                	}else if(code == "00177-E"/*A6121*/ || code == "01657-E"/*A6257*/ ||
            	                			code == "00853-E"/*W6124*/ || code == "00179-E"/*W6002*/ ||
            	                			code == "01961-E"/*W6123*/ || code == "01962-E"/*W6344*/ ||
            	                			code == "00751-E"/*W6133*/ || code == "00166-E"/*A6131*/ ||
            	                			code == "00573-E"/*W2589*/ || code == "00872-E"/*W2173*/
    	                			){
            	                		var payrollNavNum = commonServices.storage().get('PAYROLL_NAVNUM');
                                		var payrollNavNumSelected = commonServices.storage().get('PAYROLL_NAVNUMSELECTED');
                                		_transferInterruptTest(payrollNavNum, payrollNavNumSelected, code, message);
										if ($rootScope.currentTab == "tab.setting") {
                                        	$state.go('tab.setting-page-payroll-overview');
                                    	} else {
                                        	$state.go('tab.page-payroll-overview');
                                    	}
            	                	}else if(code == "00201-E"/*W6135*/ && utility.hasValue(commonServices.storage().get('PAYROLL_NAVNUMSELECTED')) && commonServices.storage().get('PAYROLL_NAVNUMSELECTED') ==1){
            	                		//story 1986
            	                		//stay at the current page
                                    }else if(code === "00202-E"/*W1718*/ && utility.hasValue(commonServices.storage().get('PAYROLL_NAVNUMSELECTED')) && commonServices.storage().get('PAYROLL_NAVNUMSELECTED') ===1){
                                        //BCM-81 stay at the current page
                                    }
                                }
                            }]
                		);               	                   
	                };
					
					commonServices.sendRequest({
						url: 'transferconfirm',
						data: params,
						config: {
							'ACCNT_INF_SIA': CONSTS.DIRECT_API.ACCOUNT_DETAILS.ACCNT_INF_SIA
						},
		                //error handle
		                onCodeError: onCodeError,
		                scope: $rootScope
					}).then(function(res7486K){
						utility.showBusy();
						console.log('service MIA7486 imgKakuninSap.y call sucess');
						var PAYROLL_MIA7486K = utility.clone(res7486K.data);
						_merageNickName(PAYROLL_MIA7486K.BANK_NM_IN,PAYROLL_MIA7486K.BRANCH_NM_IN,
								PAYROLL_MIA7486K.ACCNT_TYPE_NM_IN,PAYROLL_MIA7486K.ACCNT_NO_IN,PAYROLL_MIA7486K.RECEIVER_NM_KN).then(
							function(recMer){
								console.log('service MIA7486 imgKakuninSap.y1 call error');
								PAYROLL_MIA7486K.ACCNT_INF_OUT = _searchAccount(PAYROLL_MIA7486K.ACCNT_IDX,PAYROLL_MIA7486K.ACCNT_INF_SIA,PAYROLL_MIA7486K.ACCNT_CNT_SIA);
								PAYROLL_MIA7486K.nickname = recMer.nickname;
								PAYROLL_MIA7486K.avatar = recMer.avatar;
								PAYROLL_MIA7486K.displayNickname = recMer.displayNickname;
								commonServices.storage().set('PAYROLL_MIA7486K',PAYROLL_MIA7486K);
								deferred.resolve({code:'0',data:{message:'MIA7486 imgKakuninSap.y sucess'}});
							},
							function(errMer){
								console.log('service MIA7486 imgKakuninSap.y2 call error' + errMer);
								deferred.reject({code:'1',data:{message:errMer}});
							}
						);
					}, function(error){
						console.log('service MIA7486 imgKakuninSap.y call error');
						commonServices.storage().set('PAYROLL_MIA7486K',null);
						deferred.reject({code:'1',data:{message:error}});
					});
				}, function(error){
					console.log('service MIA7486 imgZandakaSap.y call error');
					commonServices.storage().set('PAYROLL_MIA7486Z',null);
					deferred.reject({code:'1',data:{message:error}});
				});
			},function(error){
				console.log('service MIA7482 imgFurikomiSelectSap.y call error');
				commonServices.storage().set('PAYROLL_MIA7482',null);
				deferred.reject({code:'1',data:{message:error}});
			});
			
			return deferred.promise;
        },
        reqTransferInData : function(item,scope){        	
        	var deferred = $q.defer();
        	_reqTransferInData(item,scope).then(
				function(res7821) {
					deferred.resolve(res7821);
				},
				function(error) {
					deferred.reject(error);
				}
			);
			return deferred.promise;
	    },
	    confirmToTransfer:function(isNeed7480,scope,item,PAYROLL_TRANSFEROUTLISTS){
	    	var deferred = $q.defer();
	    	
	    	if(isNeed7480 == 0){
	    		deferred.resolve({code:'0',data:{message:'success'}});
	    		return deferred.promise;
	    	}
					
			var params = {};
			var onCodeError = null;
			var url = null;
			var config = {};
			
			params = {
				TrxID : 'MIA7820',
				'imgFurikomiSap.y' : '1'
			};
			url = 'hastransfer';
			config = {};
			onCodeError=function(code, message, scope) {
				commonServices.showAlert(utility.format(Messages.FORMAT_ERROR_CODE, [code]),
                    message, [{
                        text: Messages.YES
                    }]
				);
            };
			
			commonServices.sendRequest({
				data: params,
				url: url,
				config: config,
				onCodeError:onCodeError
			}).then(
				function(res7820){
					utility.showBusy();
					commonServices.storage().set('PAYROLL_MIA7820_OUT',res7820.data);
					
					var params7480 = {
						TrxID : 'MIA7480',
						'imgFurikomiSap.y' : '1'
					};

					commonServices.sendRequest({
						url: 'payees',
						data: params7480,
						config: {
							'REGI_ACCNT_INF_SIA': CONSTS.DIRECT_API.ACCOUNT_DETAILS.REGI_ACCNT_INF_SIA
						},
						onCodeError: onCodeError,
						scope: scope
					}).then(
						function(response){
							utility.showBusy();
							commonServices.storage().set('transferOutFrom7480',response);
							
//							var siaLength = 0;
//							var keys = []
//							if(utility.hasValue(response) && utility.hasValue(response.data)  && utility.hasValue(response.data.REGI_ACCNT_INF_SIA)){
//								keys = Object.keys(response.data.REGI_ACCNT_INF_SIA);
//								siaLength = keys.length;
//							}
							
							var isDel = _showTransferOutAllError(response.data.REGI_ACCNT_INF_SIA,PAYROLL_TRANSFEROUTLISTS);
							var PAYROLL_TRANSFEROUTLISTS_NOCHANGE = [];
							for(var i = 0; utility.hasValue(PAYROLL_TRANSFEROUTLISTS) && i < PAYROLL_TRANSFEROUTLISTS.length; i++){
								if(!PAYROLL_TRANSFEROUTLISTS[i].showerrorflag){
									PAYROLL_TRANSFEROUTLISTS_NOCHANGE.push(PAYROLL_TRANSFEROUTLISTS[i]);
								}
							}
							if(PAYROLL_TRANSFEROUTLISTS_NOCHANGE.length > 0){
								var siaLength = PAYROLL_TRANSFEROUTLISTS_NOCHANGE.length;
								_loopCheckFor7482(response.data, 0, siaLength, isNeed7480,scope,item,PAYROLL_TRANSFEROUTLISTS_NOCHANGE).then(
										function(result) {
											console.log('Loop for 7482 success!');
											deferred.resolve({code:'0',data:{message:'success'}});
										},
										function(error){
											console.log('Loop for 7482 error' + error);
											deferred.reject({code:'1',data:{message:'faile'}});
										}
									);
							}else{
								console.log('All accounts have been changed');
								deferred.resolve({code:'0',data:{message:'success'}});
							}
						},
						function(error){
							commonServices.storage().set('transferOutFrom7480',null);
							deferred.reject({code:'1',data:{message:'faile'}});
						}
					)
				},
				function(error){
					commonServices.storage().set('PAYROLL_MIA7820_IN',null);
					commonServices.storage().set('PAYROLL_MIA7820_OUT',null);
					console.log('The IF 7820 call error' + error);
					deferred.reject({code:'1',data:{message:'faile'}});
				}
			);
			
			return deferred.promise;
	    },
	    commitTransferOut:function(item,scope,swotpSkipFlag,sndCheckFlag){
			// 多重にならないよう、確実にindicatorを表示する
			utility.showBusy();
	    	var deferred = $q.defer();
	    	
	    	var tranId = 'MIA7487';
			if(item.RESERVE_FLG == CONSTS.RESERVE_FLG.APPOINT){
				tranId = 'MIA74a7';
			}
			var buttonName = null;
			var params = {
				TrxID : tranId,
				JIZEN_TSUIKA: transferOutService.converNullToBlank(item.JIZEN_TSUIKA),
				SWKB_FLG: '0',
				PASSWD2_1: '',
				PASSWD2_2: '',
				V_OTPW_PASSWORD: transferOutService.converNullToBlank(item.V_OTPW_PASSWORD),
				CHECK_ITEM: transferOutService.converNullToBlank(item.CHEDK_ITEM_GLOBEL),
				secondPwdCheck: transferOutService.converNullToBlank(item.secondPwdCheck),
				STS_CHK_FLG:item.STS_CHK_FLG
			};
			onCodeError = function(code, message, scope){
				utility.hideBusy();
                if(code === "00138-E"/*A5620*/ && sndCheckFlag === CONSTS.SND_PWD_CHECK.YES && swotpSkipFlag === CONSTS.PASSCARD_SKIP_FLAG.YES){
                    //cashless-1550認証エラー（A5620）発生時,時刻補正確認Popuは表示(Native)
                    var nativePopupPlugin = new NativePopupPlugin();
                    var options = {
                        errorCode: code,
                        errorMsg: message
                    };
                    var onSuccess = function(){
                    	console.log("show native popup successfully");
                        var onSuccessFromPopup = function(){
                        	console.log("go to time adjust page successfully");
                        };
                        var onErrorFromPopup = function(){
                            console.log("go to time adjust page failed");
                        };
                        //cashless-1987 【まとめて振込】OTPW認証エラー時のポップアップから時刻補正設定処理を行う(Hybrid android)
                        nativePopupPlugin.openTimeAdjust([], onSuccessFromPopup, onErrorFromPopup);
                        console.log("show native popup successfully");
                    };
                    var onError = function(){
                    	console.log("show native popup failed");
                    };
                    // CASHLESS-7879 A5620のpopupはリンク対応のため、hybrid側で表示する。(時刻補正確認PopupはNativeのまま)
                    commonServices.showAlert(utility.format(Messages.FORMAT_ERROR_CODE, [code]),
                        //                    utility.replaceHref(message),
                        message,
                        [{
                            text : Messages.YES,
                            onTap : function(evt) {
                                nativePopupPlugin.showNativePopup(options, onSuccess, onError);
                            }
                        }]);
                }else{
					commonServices.showAlert(utility.format(Messages.FORMAT_ERROR_CODE, [code]),
	//                    utility.replaceHref(message),
						  message,
						[{
							text : Messages.YES,
							onTap : function(evt) {
								if(code == "00191-E"/*A5010*/ || code == "00192-E"/*A1564*/ ||
									code == "00186-E"/*A6678*/ || code === '00194-E'/*A6659*/ || code === '02838-E'/*A6659*/ || code === '02839-E'/*A6659*/ ||
									code == "00199-E"/*A6136*/ || code == "00198-E"/*A6340*/ ||
									code == "00201-E"/*A6135*/ || code === "00197-E"/*A1869*/ || code === '00195-E'/*W6268*/ || code === '02840-E'/*W6268*/ || code === '02841-E'/*W6268*/)
								{
									var PAYROLL_MIA7482 = commonServices.storage().get('PAYROLL_MIA7482');
									var data = new Object();
									data.ACCNT_IDX = item.accntIdx;
									data.CLIENT_NM = PAYROLL_MIA7482.MEMBER_KANA_NAME;
									data.TEL_OUT = PAYROLL_MIA7482.MEMBER_TEL_NO;
									data.RECEIVER_NM_KN = PAYROLL_MIA7482.RECEIVER_NM_KN;
									utility.showBusy();
									_reqTransferOutEditData(data,scope).then(
									   function(res1){
										   utility.hideBusy();
											if ($rootScope.currentTab == "tab.setting") {
												$state.go('tab.setting-page-confirm-edit');
											}else{
												$state.go('tab.page-confirm-edit');
											}
									   },
									   function(error1){
										   utility.hideBusy();
										   console.log(error1);
									   }
									);
								}else if(code == "01503-E"/*W1684*/ || code == "01184-E"/*W5617*/ ||
										code == "00003-E"/*W5618*/ || code == "00007-E"/*W5619*/ ||
										code == "00138-E"/*A5620*/)
								{
									//stay on the current page
								}else if(code == "00179-E"/*W6002*/ || code == "00177-E"/*A6121*/ ||
										code == "00200-E"/*A5033*/ || code == "00213-E"/*A6405*/ ||
									    code == "02738-E" || code == "02501-E" || code == "02502-E" ||
										code === "00185-E"/*A6122*/ || code === "02844-E"/*A6122*/ ||
										code == "02832-E"/*A6122*/ || code == "02833-E"/*A6122*/ || code == "02834-E"/*A6122*/ ||
										code == "02835-E"/*A6122*/ || code == "02836-E"/*A6122*/ || code == "02837-E"/*A6122*/)
								{
									//goto the finish page
									var payrollNavNum = commonServices.storage().get('PAYROLL_NAVNUM');
									var payrollNavNumSelected = commonServices.storage().get('PAYROLL_NAVNUMSELECTED');
									_transferInterruptTest(payrollNavNum, payrollNavNumSelected, code, message);
									if ($rootScope.currentTab == "tab.setting") {
										$state.go('tab.setting-page-payroll-overview');
									} else {
										$state.go('tab.page-payroll-overview');
									}
								}
							}
						}]
					);
                }
        	}			
			
			if(item.PIN_MODE_FLG == '1') {
				params['imgNewOtpwKakuninSap.y'] = '1';
				buttonName = 'imgNewOtpwKakuninSap.y';
			}else {
				params['imgNewFuriKakuninSap.y'] = '1';
				buttonName = 'imgNewFuriKakuninSap.y';
			}
			commonServices.sendRequest({
				url: 'transferfinish',
				data: params,
				config: {
					'ACCNT_INF_SIA': CONSTS.DIRECT_API.ACCOUNT_DETAILS.ACCNT_INF_SIA
				},
                onServerError: function(status, message) {
             	   console.log("onServerError");
             	  transferOutRequestService.transferOutInButtonClick("TransferOUT");
                },
                //error handle
                onCodeError: onCodeError,
				scope: $rootScope
			}).then(function(response){
				utility.showBusy();
				 smbcDataStore.set('ACCOUNT_DATA_STATUS', CONSTS.CODE.ACCOUNT_STATUS.CHANGED);
				 transferOutService.setDataForMIA7487aOr74a7a(response.data);
				console.log('The IF ' + tranId + buttonName + ' call sucess');
				var MIA7487orMIA74a7 = utility.clone(response.data);
				MIA7487orMIA74a7.ACCNT_INF_OUT = _searchAccount(response.data.ACCNT_IDX,response.data.ACCNT_INF_SIA,response.data.ACCNT_CNT_SIA);
				_merageNickName(MIA7487orMIA74a7.BANK_NM_IN,MIA7487orMIA74a7.BRANCH_NM_IN,
						MIA7487orMIA74a7.ACCNT_TYPE_NM_IN,MIA7487orMIA74a7.ACCNT_NO_IN,MIA7487orMIA74a7.RECEIVER_NM_KN).then(
					function(recMer){
						MIA7487orMIA74a7.nickname = recMer.nickname;
						MIA7487orMIA74a7.avatar = recMer.avatar;
						MIA7487orMIA74a7.displayNickname = recMer.displayNickname;
						commonServices.storage().set('MIA7487orMIA74a7',{status:'1',type:'out',data:MIA7487orMIA74a7});
						var POINT_ERR_FLG_SIA = MIA7487orMIA74a7.POINT_ERR_FLG_SIA;
						commonServices.storage().set('POINT_ERR_FLG_SIA', POINT_ERR_FLG_SIA);
						deferred.resolve({code:'0',data:{message:'success'}});
					},
					function(errMer){
						console.log('merageNickName call error' + errMer);
						deferred.reject({code:'1',data:{message:'faile'}});
					}
				);
			}, function(error){
				console.log('The IF ' + tranId + buttonName + ' call error：' + error);
				commonServices.storage().set('MIA7487orMIA74a7',null);
				deferred.reject({code:'1',data:{message:'faile'}});
			});
			return deferred.promise;
	    },
	    reqTransferOutEditData : function(data,scope){
	    	var deferred = $q.defer();
	    	_reqTransferOutEditData(data,scope).then(
				function(req7486) {
					deferred.resolve(req7486);
				},
				function(error) {
					deferred.reject(error);
				}
			);
			return deferred.promise; 
	    },
	    reqTransferInEditData : function(scope){
	    	var deferred = $q.defer();
	    	_reqTransferInEditData(scope).then(
				function(MIA7820) {
					deferred.resolve(MIA7820);
				},
				function(error) {
					deferred.reject(error);
				}
			);
			return deferred.promise; 
	    },
	    updateTransferInEditData : function(item,scope){
			var deferred = $q.defer();
			
			// 1.MIA7821
			var option ={
				ACCNT_IDX:item.idxOut,
				ACCNT_IDX_FURIKAE:item.idxIn,
				PAY:item.pay,
			};
			option['imgFukaNextSap.y'] = '1';
			option.TrxID='MIA7821';

			onCodeError = function(code, message, scope){          	
        		commonServices.showAlert(utility.format(Messages.FORMAT_ERROR_CODE, [code]),
                    message,
                    [{
                        text : Messages.YES,
                        onTap : function(evt) {
                        	if(code == "00013-E"/*W6134*/ || code == "00011-E"/*W6348*/ ||
                    			code == "00189-E"/*A6066*/
            				){
                        		//stay at the current page
                        	}else if(code == "09000-E"/*W6002*/ || code == "09000-E"/*W6132*/ ||
	                    			code == "00751-E"/*W6133*/ || code == "00185-E"/*A6122*/ ||
	                    			code == "02842-E"/*A6122*/ || code == "02818-E"/*A6122*/ || code == "02049-E"/*A6122*/ ||
	                    			code == "00166-E"/*A6131*/ || code == "01657-E"/*A6257*/)
                        	{
                        		var payrollNavNum = commonServices.storage().get('PAYROLL_NAVNUM');
                        		var payrollNavNumSelected = commonServices.storage().get('PAYROLL_NAVNUMSELECTED');
                        		_transferInterruptTest(payrollNavNum, payrollNavNumSelected, code, message);
								if ($rootScope.currentTab == "tab.setting") {
                                	$state.go('tab.setting-page-payroll-overview');
                            	} else {
                                	$state.go('tab.page-payroll-overview');
                            	}
                        	}
                        }
                    }]
        		);            	                   
            }
			
			commonServices.sendRequest({
				url: 'accounttransferone',
				data:option,
				config: {
					'ACCNT_INF_SIA': {
						0 : 'Detail_index_ori',
						1 : 'Branch',
						2 : 'AccountName',
						3 : 'ACCNT_BL_TYPE',
						4 : 'AccountNum'
					}
				},
				onCodeError: onCodeError,
				scope: scope
			}).then(function(response){
				utility.showBusy();
				console.log('service MIA7821 call success');
				var PAYROLL_MIA7821 = utility.clone(response.data);
				PAYROLL_MIA7821.ACCNT_INF_OUT = _searchAccount(response.data.ACCNT_IDX,response.data.ACCNT_INF_SIA,response.data.ACCNT_CNT_SIA);
				PAYROLL_MIA7821.ACCNT_INF_IN = _searchAccount(response.data.ACCNT_IDX_FURIKAE,response.data.ACCNT_INF_SIA,response.data.ACCNT_CNT_SIA);
				
				commonServices.storage().set('PAYROLL_MIA7821',PAYROLL_MIA7821);
				deferred.resolve({code:'0',data:{message:'MIA7821 sucess'}});
			}, function(error){
				console.log('service MIA7821 call error');
				commonServices.storage().set('PAYROLL_MIA7821',null);
				deferred.reject({code:'1',data:{message:error}});
			});
				
			return deferred.promise;
	    },
	    reqTransferOutData25:function(item,scope,previousType){
	    	var deferred = $q.defer();
	    	var params = {};
			var onCodeError = null;
			var url = null;
			params = {
				TrxID : 'MIA7820',
				'imgFurikomiSap.y' : '1'
			};
			url = 'hastransfer';
			config = {};
			onCodeError=function(code, message, scope) {
				commonServices.showAlert(utility.format(Messages.FORMAT_ERROR_CODE, [code]),
                    message, [{
                        text: Messages.YES,
                        onTap : function(evt) {
//                        	if(code == "01620-E"/*A3000*/ || code == "00276-E"/*A3999*/){
//                        		var payrollNavNum = commonServices.storage().get('PAYROLL_NAVNUM');
//	                    		var payrollNavNumSelected = commonServices.storage().get('PAYROLL_NAVNUMSELECTED');
//	                    		_transferInterruptTest(payrollNavNum, payrollNavNumSelected, code, message);
//	                    		$state.go('tab.page-payroll-overview');
//                        	}                        	
                        }
                    }]
				);
            };
            
            commonServices.sendRequest({
				data: params,
				url: url,
				config: config,
				onServerError: function(status, message) {
					console.log("onServerError");
					transferOutRequestService.transferOutInButtonClick(previousType);
				},
				onCodeError: onCodeError
			}).then(
				function(res7820){
					utility.showBusy();
					commonServices.storage().set('PAYROLL_MIA7820_OUT',res7820.data);
					
					var params7480 = {
						TrxID : 'MIA7480',
						'imgFurikomiSap.y' : '1'
					};
					onCodeError=function(code, message, scope) {
						commonServices.showAlert(utility.format(Messages.FORMAT_ERROR_CODE, [code]),
		                    message, [{
		                        text: Messages.YES,
		                        onTap : function(evt) {
		                        	if(code == "00863-E"/*W1528*/ || code == "00858-E"/*W1522*/ ||
	                        			code == "00864-E"/*W1529*/ || code == "00859-E"/*W1523*/ ||
	                        			code == "01657-E"/*A6257*/ || code == "00306-E"/*A6390*/ ||
	                        			code == "01772-E"/*A6392*/ || code == "00105-E"/*A6401*/ ||
	                        			code == "02355-E"/*W2191*/)
		                        	{
		                        		var payrollNavNum = commonServices.storage().get('PAYROLL_NAVNUM');
			                    		var payrollNavNumSelected = commonServices.storage().get('PAYROLL_NAVNUMSELECTED');
			                    		_transferInterruptTest(payrollNavNum, payrollNavNumSelected, code, message);
										if ($rootScope.currentTab == "tab.setting") {
                                        	$state.go('tab.setting-page-payroll-overview');
                                    	} else {
                                        	$state.go('tab.page-payroll-overview');
                                    	}
		                        	}                        	
		                        }
		                    }]
						);
		            };
					commonServices.sendRequest({
						url: 'payees',
						data: params7480,
						config: {
							'REGI_ACCNT_INF_SIA': CONSTS.DIRECT_API.ACCOUNT_DETAILS.REGI_ACCNT_INF_SIA
						},
						onServerError: function(status, message) {
							console.log("onServerError");
							transferOutRequestService.transferOutInButtonClick(previousType);
						},
						onCodeError: onCodeError,
						scope: scope
					}).then(
						function(response){
							utility.showBusy();
							var REGI_no = item.REGI_no;
							var new7480 = utility.clone(response);
							var isNeedInterrupt = false;
							var isChanged = true;
							if(utility.hasValue(new7480) && 
									utility.hasValue(new7480.data) && 
									utility.hasValue(new7480.data.REGI_ACCNT_INF_SIA)){
								var new7480Data = new7480.data.REGI_ACCNT_INF_SIA;
								for(var j in new7480Data){
									if(item.number == new7480Data[j].Account_no && 
											item.bank_code == new7480Data[j].Bank_code && 
											item.bank == new7480Data[j].Bank_name && 
											item.branch_code== new7480Data[j].Branch_code && 
											item.branch == new7480Data[j].Branch_name &&
											item.type == new7480Data[j].Account_type && 
											item.account_name == new7480Data[j].Account_name){
										REGI_no = new7480Data[j].REGI_no;
										isChanged = false;
										break;
									}
								}
								if(isChanged){
									// interrupt
									isNeedInterrupt = true;
								}
							}else{
								// interrupt
								isNeedInterrupt = true;
							}
							if(isNeedInterrupt){
								deferred.resolve({code:'2',data:{message:'process need interrupt.'}});
								return deferred.promise;
							}
							
							commonServices.storage().set('transferOutFrom7480',response);
							
//							//defect2139
//							var REGI_no = {};
//							for(var i in response.data.REGI_ACCNT_INF_SIA){
//								if(item.REGI_no == response.data.REGI_ACCNT_INF_SIA[i].REGI_no){
//									REGI_no = item.REGI_no;
//									break;
//								}else{
//									REGI_no = response.data.REGI_ACCNT_INF_SIA[0].REGI_no;
//								}
//							}
							
							// 『選択』押下時　＝＞ 「振込先」を選択時
							// 1.MIA7482 imgFurikomiSelectSap.y
							var params = {
								TrxID : 'MIA7482',
								TORIHIKI_KBN : '1',
//								REGIST_NO : transferOutService.converNullToBlank(item.REGI_no),
								REGIST_NO : transferOutService.converNullToBlank(REGI_no),
								rdoNyukin : '0',
								FURIKOMI_KUBUN : '01',
								'imgFurikomiSelectSap.y' : '1'
							};
							onCodeError = function(code, message, scope){          	
				        		commonServices.showAlert(utility.format(Messages.FORMAT_ERROR_CODE, [code]),
//				                    utility.replaceHref(message),
				        			message,
				                    [{
				                        text : Messages.YES,
				                        onTap : function(evt) {
				                        	if(code == "00177-E"/*A6121*/ || code == "00863-E"/*W1528*/ ||
			                        			code == "00860-E"/*W6720*/ ||
			                        			code == "00853-E"/*W6124*/ || code == "00185-E"/*A6122*/ || code == "02049-E"/*A6122*/ ||
			                        			code === "02844-E"/*A6122*/ || code === "02832-E"/*A6122*/ || code === "02833-E"/*A6122*/ || code === "02834-E"/*A6122*/ ||
			                        			code === "02835-E"/*A6122*/ || code === "02836-E"/*A6122*/ || code === "02837-E"/*A6122*/ ||
			                        			code == "00182-E"/*A6421*/ || code == "02018-E"/*A6425*/ ||
			                        			code == "02019-E"/*A6426*/ || code == "00864-E"/*W1529*/
	                        				){
					                        	var payrollNavNum = commonServices.storage().get('PAYROLL_NAVNUM');
					                    		var payrollNavNumSelected = commonServices.storage().get('PAYROLL_NAVNUMSELECTED');
					                    		_transferInterruptTest(payrollNavNum, payrollNavNumSelected, code, message);
												if ($rootScope.currentTab == "tab.setting") {
                                                	$state.go('tab.setting-page-payroll-overview');
                                            	} else {
                                                	$state.go('tab.page-payroll-overview');
                                            	}
				                        	}
				                        }
				                    }]
				        		);            	                   
				            };
							
							commonServices.sendRequest({
								data: params,
								url: 'transferaccountlistbybank',
								config: {
									'ACCNT_INF_SIA': CONSTS.DIRECT_API.ACCOUNT_DETAILS.ACCNT_INF_SIA
								},
								onServerError: function(status, message) {
									console.log("onServerError");
									transferOutRequestService.transferOutInButtonClick(previousType);
								},
								onCodeError: onCodeError,
								scope: scope
							}).then(function(res7482){
								utility.showBusy();
								console.log('service MIA7482 imgFurikomiSelectSap.y call sucess');
								commonServices.storage().set('PAYROLL_MIA7482', res7482.data);
								
								// 『残高照会』押下時 => 「口座」選択時
								// 2.MIA7486 imgZandakaSap.y
								var params = {
									TrxID : 'MIA7486',
									'imgZandakaSap.y' : '1',
									ACCNT_IDX : transferOutService.converNullToBlank(item.accntIdx),
									CLIENT_NM : commonServices.encodeUnicodeString(transferOutService.converNullToBlank(res7482.data.MEMBER_KANA_NAME)),
									TEL_OUT : transferOutService.converNullToBlank(res7482.data.MEMBER_TEL_NO),
									PAY : item.value,
									TESURYO_KOMI : '0',
									SELECT_USE_POINT : '0',
									CHG_YUGU_RATE : '',
									CHARGE_YUGU_IN : '0',
									RECEIVER_NM_KN : commonServices.encodeUnicodeString(transferOutService.converNullToBlank(res7482.data.RECEIVER_NM_KN)),
									FURIKOMI_SHITEI_IDX : '0',
									BANCS_DISP_MSG_FLG : '0'
								};
								onCodeError = function(code, message, scope){          	
					        		commonServices.showAlert(utility.format(Messages.FORMAT_ERROR_CODE, [code]),
//					                    utility.replaceHref(message),
					        			message,
					                    [{
					                        text : Messages.YES,
					                        onTap : function(evt) {
					                        	if(code == "00179-E"/*W6002*/){
					                        		var payrollNavNum = commonServices.storage().get('PAYROLL_NAVNUM');
						                    		var payrollNavNumSelected = commonServices.storage().get('PAYROLL_NAVNUMSELECTED');
						                    		_transferInterruptTest(payrollNavNum, payrollNavNumSelected, code, message);
													if ($rootScope.currentTab == "tab.setting") {
	                                                	$state.go('tab.setting-page-payroll-overview');
	                                            	} else {
	                                                	$state.go('tab.page-payroll-overview');
	                                            	}
					                        	}		                        	
					                        }
					                    }]
					        		);            	                   
					            }
								commonServices.sendRequest({
									url: 'transferreceiverdetail',
									data: params,
									config: {
										'FURIKOMI_SHITEI_INF_SIA': CONSTS.DIRECT_API.ACCOUNT_DETAILS.FURIKOMI_SHITEI_INF_SIA
									},
									onServerError: function(status, message) {
										console.log("onServerError");
										transferOutRequestService.transferOutInButtonClick(previousType);
									},
									onCodeError: onCodeError,
									scope: scope
									// ,onCodeError: cusCodeError
								}).then(function(res7486Z){
									utility.showBusy();
									console.log('service MIA7486 imgZandakaSap.y call sucess');
									commonServices.storage().set('PAYROLL_MIA7486Z', res7486Z.data);
									
									// 確認画面へ
									// 3.MIA7486 imgKakuninSap.y
									var params = {
										TrxID : 'MIA7486',
										'imgKakuninSap.y' : '1',
										ACCNT_IDX : res7486Z.data.ACCNT_IDX,
										CLIENT_NM : commonServices.encodeUnicodeString(transferOutService.converNullToBlank(res7486Z.data.CLIENT_NM)),
										TEL_OUT : transferOutService.converNullToBlank(res7486Z.data.TEL_OUT),
										PAY : res7486Z.data.PAY,
										TESURYO_KOMI : '0',
										SELECT_USE_POINT : '0',
										CHG_YUGU_RATE : '',
										CHARGE_YUGU_IN : '0',
										RECEIVER_NM_KN : commonServices.encodeUnicodeString(transferOutService.converNullToBlank(res7486Z.data.RECEIVER_NM_KN)),// 'ｱｲｳｴｵｶｷｸｹ',
										FURIKOMI_SHITEI_IDX : '0',
										BANCS_DISP_MSG_FLG : '0'
									};
									onCodeError = function(code, message, scope){	                	
				                		commonServices.showAlert(utility.format(Messages.FORMAT_ERROR_CODE, [code]),
//				                            utility.replaceHref(message),
				                			message,
				                            [{
				                                text : Messages.YES,
				                                onTap : function(evt) {
				                                	if(code == "00000-E"/*W6137*/ || code == "00002-E"/*W6341*/ || code == "00007-E"/*W6341*/ ||
				                            			code == "00000-E"/*W6148*/ || code == "00868-E"/*W6140*/ ||
				                            			code == "00054-E"/*W6139*/ || code == "00000-E"/*W6141*/ || code == "00018-E"/*W6141*/ || code == "00013-E"/*W6141*/ ||
				        	                			code == "00011-E"/*W6345*/ || code == "00866-E"/*W6138*/ ||
				        	                			code == "00201-E"/*W6135*/ || code == "00869-E"/*W1570*/ ||
                                                        code === "00202-E"/*W1718*/ ||
                                                        code == "00870-E"/*W1571*/ || code == "00871-E"/*W5008*/ ||
				        	                			code == "00190-E"/*A5009*/ || code == "00191-E"/*A5010*/ ||
				        	                			code == "00187-E"/*A6337*/ || code == "00203-E"/*A6337*/ || code == "00186-E"/*A6678*/ ||
				        	                			code == "00189-E"/*A6339*/ || code == "00198-E"/*A6340*/ ||
				        	                			code == "02086-I"/*W1694*/)
				            	                	{					                                						                                		
				                                		//when request 7846 Kakunin error, request 7846 Zandaka again to jump to the edit page
				                                		var data = utility.clone(commonServices.storage().get('PAYROLL_MIA7482')); 
				                                		var group = utility.clone(commonServices.storage().get('PAYROLL_GROUPINFO'));
				                                		
				                                		data.ACCNT_IDX =  group.pay_account_index1;
				                                		data.CLIENT_NM = data.MEMBER_KANA_NAME;
				                                		data.TEL_OUT = data.MEMBER_TEL_NO;
				                                		data.RECEIVER_NM_KN = data.RECEIVER_NM_KN;
				                                	    
				                                		utility.showBusy();
				                                		_reqTransferOutEditData(data, scope).then(
				                            				function(result) {                           					
				                            					console.log('success');
				                            					//is the previous page "group-confirm" or "confirm-edit"
						                                		commonServices.storage().set('PAYROLL_JUMP_ERROR', true);
						                                		utility.hideBusy();
									                			if ($rootScope.currentTab == "tab.setting") {
							   										$state.go('tab.setting-page-confirm-edit');
							  									}else{
							  										$state.go('tab.page-confirm-edit');
							  									}
				                            				},
				                            				function(error) {
				                            					utility.hideBusy();
				                            					console.log('error');
				                            				}
				                            			);
				            	                	}else if(code == "00177-E"/*A6121*/ || code == "01657-E"/*A6257*/ ||
				            	                			code == "00853-E"/*W6124*/ || code == "00179-E"/*W6002*/ ||
				            	                			code == "01961-E"/*W6123*/ || code == "01962-E"/*W6344*/ ||
				            	                			code == "00751-E"/*W6133*/ || code == "00166-E"/*A6131*/ ||
				            	                			code == "00573-E"/*W2589*/ || code == "00872-E"/*W2173*/
				            	                	){
				            	                		var payrollNavNum = commonServices.storage().get('PAYROLL_NAVNUM');
				                                		var payrollNavNumSelected = commonServices.storage().get('PAYROLL_NAVNUMSELECTED');
				                                		_transferInterruptTest(payrollNavNum, payrollNavNumSelected, code, message);
														if ($rootScope.currentTab == "tab.setting") {
		                                                	$state.go('tab.setting-page-payroll-overview');
		                                            	} else {
		                                                	$state.go('tab.page-payroll-overview');
		                                            	}
				            	                	}
				                                }
				                            }]
				                		);               	                   
					                };																		
									commonServices.sendRequest({
										url: 'transferconfirm',
										data: params,
										config: {
											'ACCNT_INF_SIA': CONSTS.DIRECT_API.ACCOUNT_DETAILS.ACCNT_INF_SIA
										},
										onServerError: function(status, message) {
											console.log("onServerError");
											transferOutRequestService.transferOutInButtonClick(previousType);
										},
										onCodeError: onCodeError,
										scope: $rootScope
									}).then(function(res7486K){
										utility.showBusy();
										console.log('service MIA7486 imgKakuninSap.y call sucess');
										var PAYROLL_MIA7486K = utility.clone(res7486K.data);
										_merageNickName(PAYROLL_MIA7486K.BANK_NM_IN,PAYROLL_MIA7486K.BRANCH_NM_IN,
												PAYROLL_MIA7486K.ACCNT_TYPE_NM_IN,PAYROLL_MIA7486K.ACCNT_NO_IN,PAYROLL_MIA7486K.RECEIVER_NM_KN).then(
											function(recMer){
												console.log('service MIA7486 imgKakuninSap.y1 call error');
												PAYROLL_MIA7486K.ACCNT_INF_OUT = _searchAccount(PAYROLL_MIA7486K.ACCNT_IDX,PAYROLL_MIA7486K.ACCNT_INF_SIA,PAYROLL_MIA7486K.ACCNT_CNT_SIA);
												PAYROLL_MIA7486K.nickname = recMer.nickname;
												PAYROLL_MIA7486K.avatar = recMer.avatar;
												PAYROLL_MIA7486K.displayNickname = recMer.displayNickname;
												commonServices.storage().set('PAYROLL_MIA7486K',PAYROLL_MIA7486K);
												deferred.resolve({code:'0',data:{message:'MIA7486 imgKakuninSap.y sucess'}});
											},
											function(errMer){
												console.log('service MIA7486 imgKakuninSap.y2 call error' + errMer);
												deferred.reject({code:'1',data:{message:errMer}});
											}
										);
									}, function(error){
										console.log('service MIA7486 imgKakuninSap.y call error');
										commonServices.storage().set('PAYROLL_MIA7486K',null);
										deferred.reject({code:'1',data:{message:error}});
									});
								}, function(error){
									console.log('service MIA7486 imgZandakaSap.y call error');
									commonServices.storage().set('PAYROLL_MIA7486Z',null);
									deferred.reject({code:'1',data:{message:error}});
								});
							},function(error){
								console.log('service MIA7482 imgFurikomiSelectSap.y call error');
								commonServices.storage().set('PAYROLL_MIA7482',null);
								deferred.reject({code:'1',data:{message:error}});
							});
						},
						function(error){
							commonServices.storage().set('transferOutFrom7480',null);
							deferred.reject({code:'1',data:{message:'faile'}});
						}
					)
				},
				function(error){
					commonServices.storage().set('PAYROLL_MIA7820_IN',null);
					commonServices.storage().set('PAYROLL_MIA7820_OUT',null);
					console.log('The IF 7820 call error' + error);
					deferred.reject({code:'1',data:{message:'faile'}});
				}
			);
                
	    	return deferred.promise;
	    },
	    reqTransferInData25 : function(item,scope,previousType){
			var deferred = $q.defer();
			
			// 1.MIA7820
			var params = {};
			var onCodeError = null;
			var url = null;
			params = {
				TrxID : 'MIA7820',
				'imgFurikaeSap.y' :'1'
			};
			url = 'accounttransfer';
			config = {
				'ACCNT_INF_SIA': {
					0 : 'Detail_index_ori',
					1 : 'Branch',
					2 : 'AccountName',
					3 : 'ACCNT_BL_TYPE',
					4 : 'AccountNum'
				}
			};
			onCodeError=function(code, message, scope){
				commonServices.showAlert(utility.format(Messages.FORMAT_ERROR_CODE, [code]),
					utility.replaceHref(message),
					[{
						text : Messages.YES,
						onTap : function(evt) {
							if(code == "00839-E"/*W6262*/){
								var payrollNavNum = commonServices.storage().get('PAYROLL_NAVNUM');
	                    		var payrollNavNumSelected = commonServices.storage().get('PAYROLL_NAVNUMSELECTED');
	                    		_transferInterruptTest(payrollNavNum, payrollNavNumSelected, code, message);
								if ($rootScope.currentTab == "tab.setting") {
                                	$state.go('tab.setting-page-payroll-overview');
                            	} else {
                                	$state.go('tab.page-payroll-overview');
                            	}
                        	}
						}
					}]
				);
			};
			
			commonServices.sendRequest({
				data: params,
				url: url,
				config: config,
				onServerError: function(status, message) {
					console.log("onServerError");
					transferOutRequestService.transferOutInButtonClick(previousType);
				},
				onCodeError:onCodeError
			}).then(
				function(res7820){
					utility.showBusy();
					console.log('The IF MIA7820 imgFurikaeSap.y call success');
					commonServices.storage().set('PAYROLL_MIA7820_IN',res7820.data);
					
					//Defect 2118
					var servicesFirstAccountList = utility.clone(commonServices.storage().get('PAYROLL_MIA7820_IN').ACCNT_INF_SIA);
					var newNextAccountInObj;
					var newNextAccountOutObj;
					for(var i in servicesFirstAccountList){
						if((servicesFirstAccountList[i].Branch === item.branchname) && (servicesFirstAccountList[i].AccountName === item.type) && 
								(servicesFirstAccountList[i].ACCNT_BL_TYPE === item.account_type_code) && (servicesFirstAccountList[i].AccountNum === item.number)){
							newNextAccountInObj = utility.clone(servicesFirstAccountList[i]);
						}
						if((servicesFirstAccountList[i].Branch === item.Branch) && (servicesFirstAccountList[i].AccountName === item.AccountName) && 
								(servicesFirstAccountList[i].ACCNT_BL_TYPE === item.pay_account_type_code) && (servicesFirstAccountList[i].AccountNum === item.AccountNum)){
							newNextAccountOutObj = utility.clone(servicesFirstAccountList[i]);
						}
					}
					
					// 2.MIA7821
					var option ={
						ACCNT_IDX:newNextAccountOutObj.Detail_index_ori,
						ACCNT_IDX_FURIKAE:newNextAccountInObj.Detail_index_ori,
						PAY:item.value.toString().replace(/\b(0+)/gi,""),
					};
					option['imgFukaNextSap.y'] = '1';
					option.TrxID='MIA7821';

					onCodeError = function(code, message, scope){          	
		        		commonServices.showAlert(utility.format(Messages.FORMAT_ERROR_CODE, [code]),
		                    message,
		                    [{
		                        text : Messages.YES,
		                        onTap : function(evt) {
		                        	if(code == "00013-E"/*W6134*/ || code == "00011-E"/*W6348*/ ||
	                        			code == "00189-E"/*A6066*/
                    				){	
		                        		utility.showBusy();
		                        		_reqTransferInEditData(scope).then(
	                        				function(result) { 
	                        					console.log('success');
	                        					utility.hideBusy();
	                        					commonServices.storage().set('PAYROLL_IN_EDIT_DATA',null);
					                			if ($rootScope.currentTab == "tab.setting") {
			   										$state.go('tab.setting-page-confirm-edit-amount');
			  									}else{
			  										$state.go('tab.page-confirm-edit-amount');
			  									}
	                        				},
	                        				function(error) {
	                        					utility.hideBusy();
	                        					console.log('error');
	                        				}
	                        			);
		                        		
		                        	}else if(code == "09000-E"/*W6002*/ || code == "09000-E"/*W6132*/ ||
		                        			code == "00751-E"/*W6133*/ || code == "00185-E"/*A6122*/ ||
		                        			code == "02842-E"/*A6122*/ || code == "02818-E"/*A6122*/ || code == "02049-E"/*A6122*/ ||
	                        				code == "00166-E"/*A6131*/ || code == "01657-E"/*A6257*/)
		                        	{
		                        		var payrollNavNum = commonServices.storage().get('PAYROLL_NAVNUM');
		                        		var payrollNavNumSelected = commonServices.storage().get('PAYROLL_NAVNUMSELECTED');
		                        		_transferInterruptTest(payrollNavNum, payrollNavNumSelected, code, message);
										if ($rootScope.currentTab == "tab.setting") {
                                        	$state.go('tab.setting-page-payroll-overview');
                                    	} else {
                                        	$state.go('tab.page-payroll-overview');
                                    	}
		                        	}
		                        }
		                    }]
		                );            	                   
		            }
					
					commonServices.sendRequest({
						url: 'accounttransferone',
						data:option,
						config: {
							'ACCNT_INF_SIA': {
								0 : 'Detail_index_ori',
								1 : 'Branch',
								2 : 'AccountName',
								3 : 'ACCNT_BL_TYPE',
								4 : 'AccountNum'
							}
						},
						onServerError: function(status, message) {
							console.log("onServerError");
							transferOutRequestService.transferOutInButtonClick(previousType);
						},
						onCodeError: onCodeError,
						scope: scope
					}).then(function(response){
						utility.showBusy();
						console.log('service MIA7821 call success');
						var PAYROLL_MIA7821 = utility.clone(response.data);
						PAYROLL_MIA7821.ACCNT_INF_OUT = _searchAccount(response.data.ACCNT_IDX,response.data.ACCNT_INF_SIA,response.data.ACCNT_CNT_SIA);
						PAYROLL_MIA7821.ACCNT_INF_IN = _searchAccount(response.data.ACCNT_IDX_FURIKAE,response.data.ACCNT_INF_SIA,response.data.ACCNT_CNT_SIA);
						
						commonServices.storage().set('PAYROLL_MIA7821',PAYROLL_MIA7821);
						deferred.resolve({code:'0',data:{message:'MIA7821 sucess'}});
					}, function(error){
						console.log('service MIA7821 call error');
						commonServices.storage().set('PAYROLL_MIA7821',null);
						deferred.reject({code:'1',data:{message:error}});
					});
				},function(error){
					console.log('The IF MIA7820 imgFurikaeSap.y call error' + error);
					deferred.reject({code:'1',data:{message:error}});
				}
			);
			
			return deferred.promise;
	    },
	    commitTransferIn:function(item,scope){
	    	// 多重にならないよう、確実にindicatorを表示する
	    	utility.showBusy();
	    	var deferred = $q.defer();
	    	onCodeError = function(code, message, scope){
	    		utility.hideBusy();
	         	commonServices.showAlert(utility.format(Messages.FORMAT_ERROR_CODE, [code]),message,
     				[{
	          	       text: Messages.YES,
	          	       onTap: function(e){
	          	    	 if(code === "01963-E"/*W6255*/){
	          	    		 //stay at the current page
	          	    		 //call MIA7821 again, refresh the current page 
	          	    		var item = commonServices.storage().get('PAYROLL_MIA7821');
	          	    		utility.showBusy();
	          	    		_reqTransferInData7821(item,scope).then(
                				function(result) { 
                					console.log('success');
                					utility.hideBusy();
                					$state.reload();
                				},
                				function(error) {
                					utility.hideBusy();
                					console.log('error');
                				}
            				);	          	    		
	          	    	 }else if(code == "00213-E"/*A6405*/){
	          	    		var payrollNavNum = commonServices.storage().get('PAYROLL_NAVNUM');
                    		var payrollNavNumSelected = commonServices.storage().get('PAYROLL_NAVNUMSELECTED');
                    		_transferInterruptTest(payrollNavNum, payrollNavNumSelected, code, message);
							if ($rootScope.currentTab == "tab.setting") {
                            	$state.go('tab.setting-page-payroll-overview');
                        	} else {
                            	$state.go('tab.page-payroll-overview');
                        	}
	          	    	 }	 
          	       }}]
	         	);	          	
            }
	    	
	    	commonServices.sendRequest({
				url: 'accounttransfertwo',
				data: {
					TrxID: 'MIA7822',
					BANK_NM_IN: commonServices.encodeUnicodeString(item.BANK_NM_IN),
					'imgKakuninSap.y': '1',
					STS_CHK_FLG: item.STS_CHK_FLG
				},
				config: {
					'ACCNT_INF_SIA': {
						0 : 'Detail_index_ori',
						1 : 'Branch',
						2 : 'AccountName',
						3 : 'ACCNT_BL_TYPE',
						4 : 'AccountNum'
					}
				},
              onServerError: function(status, message) {
            	   console.log("onServerError");
            	   transferOutRequestService.transferOutInButtonClick("TransferIN");
              },
              onCodeError: onCodeError,
              scope: scope
			}).then(function(response){
				utility.showBusy();
				smbcDataStore.set('ACCOUNT_DATA_STATUS', CONSTS.CODE.ACCOUNT_STATUS.CHANGED);
				console.log('The IF MIA7822 imgKakuninSap.y call success');
				var PAYROLL_MIA7822 = utility.clone(response.data);
				
				PAYROLL_MIA7822.ACCNT_INF_OUT = _searchAccount(response.data.ACCNT_IDX,response.data.ACCNT_INF_SIA,response.data.ACCNT_CNT_SIA);
				PAYROLL_MIA7822.ACCNT_INF_IN = _searchAccount(response.data.ACCNT_IDX_FURIKAE,response.data.ACCNT_INF_SIA,response.data.ACCNT_CNT_SIA);
				commonServices.storage().set('PAYROLL_MIA7822',{status:'1',type:'in',data:PAYROLL_MIA7822});
				deferred.resolve({code:'0',data:{message:'MIA7822 imgKakuninSap.y sucess'}});
			}, function(error){
				console.log('The IF MIA7822 imgKakuninSap.y call error' + error);
				commonServices.storage().set('PAYROLL_MIA7822',null);
				deferred.reject({code:'1',data:{message:'faile'}});
			});
	    	
			return deferred.promise;
	    },
		transferInterrupt : function(payrollNavNum,payrollNavNumSelected){
			commonServices.showAlert(
					Messages.TRANSFER_OUT_CONFIRM_TITLE,
					Messages.PAYROLL_INTERRUPT_BUTTON_POPUP,
					[ {
						text : Messages.NO,
						onTap : function(e) {
						}
					},
					{
						text : Messages.YES,
						onTap : function(e) {
							_transferInterrupt(payrollNavNum,payrollNavNumSelected);
							if ($rootScope.currentTab == "tab.setting") {
                            	$state.go('tab.setting-page-payroll-overview');
                        	} else {
                            	$state.go('tab.page-payroll-overview');
                        	}
						}
					}]);
			
		},
		transferInterruptDirect : function(payrollNavNum,payrollNavNumSelected){
			_transferInterrupt(payrollNavNum,payrollNavNumSelected);
		},
		transferInterruptTest : function(payrollNavNum,payrollNavNumSelected,errCode,errMessage){
		    _transferInterruptTest(payrollNavNum,payrollNavNumSelected,errCode,errMessage);
		},
		merageNickName : function(BANK_NM_IN,BRANCH_NM_IN,ACCNT_TYPE_NM_IN,ACCNT_NO_IN,RECEIVER_NM_KN){
			var deferred = $q.defer();
			_merageNickName(BANK_NM_IN,BRANCH_NM_IN,ACCNT_TYPE_NM_IN,ACCNT_NO_IN,RECEIVER_NM_KN).then(
				function(payeeData) {
					deferred.resolve(payeeData);
				},
				function(error) {
					deferred.reject(error);
				}
			);
			return deferred.promise;
		},
		merageNickNameList:function(merageList){
			// BANK_NM_IN,BRANCH_NM_IN,ACCNT_TYPE_NM_IN,ACCNT_NO_IN,RECEIVER_NM_KN
			var deferred = $q.defer();
			var payeeList = [];
			var payeeObj = {};
			for(var i = 0; i < merageList.length; i++){
				payeeObj = new Object();
				payeeObj.Bank_name = merageList[i].bank;
				payeeObj.Branch_name = merageList[i].branch;
				payeeObj.Account_type = merageList[i].type;
				payeeObj.Account_no = merageList[i].number;
				payeeObj.Account_name = merageList[i].account_name;
				payeeList.push(payeeObj);
			}
			
			userService.mergePayeeList(payeeList).then(function(reqMer){
				console.log('merageNickName success');
				for(var i = 0; i < merageList.length; i++){
					for(var j = 0; i < payeeList.length; j++){
						if(payeeList[j].Bank_name == merageList[i].bank && 
								payeeList[j].Branch_name == merageList[i].branch &&
								payeeList[j].Account_type == merageList[i].type &&
								payeeList[j].Account_no == merageList[i].number &&
								payeeList[j].Account_name == merageList[i].account_name){
							merageList[i].name = payeeList[j].nickname;
							merageList[i].avatar = payeeList[j].avatar;
							if(utility.isNothing(merageList[i].name)){
								merageList[i].nameDisplay = false;
							}else{
								merageList[i].nameDisplay = true;
							}
							break;
						}
					}
				}
				deferred.resolve(merageList);
			}, function(error){
				console.log('merageNickName error' + error);
				deferred.reject(error);
			});
			return deferred.promise;
		},
		searchAccount : function(idx,accList,len){
			return _searchAccount(idx,accList,len);
		}
	}
});
