/* JavaScript content from payroll/js/services/payrollGroupDetail-service.js in folder common */ 
/**
 * Created by earl on 02/19/2018.
 */
smbcService.factory('payrollGroupDetailService',function($q,commonServices,$rootScope){
	
	var _updateGroupDetails = function(useFlag){
		var stagingData = smbcDataStore.get('csvDataFromStaging');
		// CASHLESS-5499: start
		console.log('payrollGroupDetailService: preparing to update database');
		if (!stagingData) {
			console.log('payrollGroupDetailService: stagingData is not avilable, trying koumei_henkou_file');
			var csvData = smbcDataStore.get('koumei_henkou_file');
			if (csvData) {
				console.log('payrollGroupDetailService: loading data from koumei_henkou_file: ' + csvData);
				stagingData = utility.parseCsvData(csvData);
			} else {
				console.log('payrollGroupDetailService: koumei_henkou_file not available');
			}
		}
		// CASHLESS-5499: end
    	var indexToUpdateArray = [];
    	var changeSuccessIndex = [];
    	var latestScreenDate = "";
    	var key = 'changeSuccessIndex';
    	var deferred = $q.defer();
		
		if(!!useFlag && !utility.isNothing(stagingData)){
            console.log('payrollGroupDetailService: updating database: ' + stagingData);
            latestScreenDate = commonServices.getLoginData().ScreenDate;
			
			if(!utility.isNothing(smbcDataStore.get(key))){
				changeSuccessIndex = smbcDataStore.get(key).split(",");
			}

			db.transaction(function(tx){
				for(var ctr = 0; ctr < stagingData.length; ctr++){
					var currentRow = stagingData[ctr].split(",");
					//servertime compare && latestScreendate >= currentRow[1], data from stagingfile is only 12 digits while screendate from server is 14
					if(!utility.isNothing(currentRow) && !(changeSuccessIndex.indexOf(currentRow[0].toString()) >= 0) && !utility.isNothing(currentRow[1]) && Number(latestScreenDate.substring(0, 12)) >= Number(currentRow[1])){
						var updateBankFlag = false;
						var updateBranchFlag = false;
						// check if bank_code,old_bank_name,new_bank_name is empty
						if(!utility.isNothing(currentRow[2]) && !utility.isNothing(currentRow[3]) && !utility.isNothing(currentRow[4])){
							updateBankFlag = true;
							tx.executeSql(SQL.Group_Detail_Update_Bank, [currentRow[4],currentRow[3],currentRow[2]], function(tx, success){
								if(success.rowsAffected > 0){
                                    console.log('####### Change Bank Name UPDATE SUCCESS #######');
								}
							},function(error){
								// to do 
							});
						}
						//check for branch entry
						if(!utility.isNothing(currentRow[2]) && !utility.isNothing(currentRow[5]) && !utility.isNothing(currentRow[6]) && !utility.isNothing(currentRow[7])){
							updateBranchFlag = true;
							tx.executeSql(SQL.Group_Detail_Update_Branch, [currentRow[7],currentRow[6],currentRow[5],currentRow[2]],function(tx, success){
								if(success.rowsAffected > 0){
                                    console.log('####### Change Branch Name UPDATE SUCCESS #######');
								}
							},function(error){
								// to do
							});
						}

						var addIndexFlag = null;

						if(updateBankFlag === false && updateBranchFlag === false){
							addIndexFlag = false;
						}else{
							addIndexFlag = utility.isNothing(currentRow[5])? updateBankFlag && utility.isNothing(currentRow[6]) && utility.isNothing(currentRow[7]) : updateBranchFlag && (utility.isNothing(currentRow[3]) === utility.isNothing(currentRow[4]));
						}

						if(addIndexFlag){
							indexToUpdateArray.push(currentRow[0]);
						}
						// else{
						// 	console.log('####### WRONG DATA FORMAT DETECTED: CDATA LINE '+ (ctr +1) +' #######');
						// }
					}
				}
			},function(error){
				console.log('####### DB UPDATE TRANSACTION ERROR #######');
				commonServices.quitApp();
				//todo for error
			},function(res){
				//no rows affected for db update function doesn't generate error and proceeds to this success callback
				if(indexToUpdateArray.length > 0){
					var newIndices = changeSuccessIndex.concat(indexToUpdateArray).join();
					commonServices.storage().save(key, newIndices);
					smbcDataStore.set(key, newIndices);
					deferred.resolve({withTransaction:true});
				}else{
					deferred.resolve({withTransaction:false});
				}
			});
		}else{
			deferred.resolve({withTransaction:false});
		}
		return deferred.promise;
	};

	return {
		updateGroupDetails : function(useFlag){
			return _updateGroupDetails(useFlag);
        }
    };
});
